#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

vector<string> tests;

#define MAX_N 100000

void gen(string p, string m, string s) {
  string pal = m;
  for (int i = m.size()-1; i >= 0; --i) {
    pal.push_back(m[i]);
  }
  string test = p;
  while (test.size() < MAX_N - s.size()) {
    test.push_back(pal[test.size() % pal.size()]);
  }
  test += s;
  tests.push_back(test);
}

const char *tab[] = {
"AAAACACCACAAAA",
"AAAACAGGAAGGAG",
"AAAACGGCAAAAGC",
"AAACCCCAAAAAGC",
"AAACCCCAAGAGCG",
"AAACCCCAGACCGG",
"AAACCGCACACGAA",
"AAAGAAGCGGGGCG",
"AAAGACCGAAAGAA",
"AAAGAGACCAGAGC",
"AAAGCCAACCGAAG",
"AACAACCAACCAAA",
"AACAACCCCAACGA",
"AACACAAGGGGGGA",
"AACACCCGCGGAGA",
"AACACGCGGACGCC",
"AACAGAAGGAAGAC",
"AACAGACCCGGCGC",
"AACCAACCAAAAAA",
"AACCAACCAACCAA",
"AACCAGGAGGAAAA",
"AACCCGCACAACCC",
"AACCGGAAAGGCCA",
"AACGCCCCGCAAGA",
"AACGCCGGAGAAAA",
"AAGAAAAGAGCGCA",
"AAGAAAAGGAAAAG",
"AAGAACGCAGCACG",
"AAGACACCCCACAC",
"AAGACCAGGACCAG",
"AAGCCGGCCGGCAC",
"AAGCGAAAAGCGAA",
"AAGCGCAGGGACGC",
"AAGGAAAAAAGGAA",
"AAGGAAGGAAGCCA",
"AAGGCAGCGCGACC",
"AAGGGAACCGGGCC",
"AAGGGGAAGGGGAA",
"ACAAAAGCGCAGGC",
"ACAACAACAACACA",
"ACAACACCACAACA",
"ACAACCCCCCAACC",
"ACAACGGGGCAACA",
"ACACAACACGAAAC",
"ACACAGGACACCAG",
"ACACAGGACCACGG",
"ACACCAACGGCGAA",
"ACACCACACCACAG",
"ACAGCCCAACGCAA",
"ACAGCCCGCCAACA",
"ACAGGGCGCCGCGA",
"ACCACCACCAAGAA",
"ACCACCACCACAGA",
"ACCACCGAACCAAG",
"ACCCCACCACCCCA",
"ACCCCAGGACCCCA",
"ACCCGGAGGAGGCC",
"ACCGAGCGACGCGA",
"ACCGCCGCCGCCGC",
"ACCGGCCCCGGCCA",
"ACCGGCCGGCCAGC",
"ACGAACCCCAAGCA",
"ACGAGACGGGGGGC",
"ACGAGCGAACAACG",
"ACGCAAGAGCCGAG",
"ACGCCGAAGCCGCC",
"ACGCGGCGCAGGAC",
"ACGGAGCAGGACGC",
"ACGGCACCACGGCA",
"ACGGCCGGCACAGA",
"ACGGGGGCAGGACG",
"AGAAAAGGAAAAGA",
"AGAAAAGGAAAAGC",
"AGAAAAGGAAAAGG",
"AGACCAGGACCAGC",
"AGAGGAGAGGCGGA",
"AGAGGGGAACGCAA",
"AGAGGGGAGGCGAA",
"AGCAAACCAAACGG",
"AGCAACGCCACCAC",
"AGCAAGACCAAGCA",
"AGCAGCACCAGACG",
"AGCCCCCCGCAAAC",
"AGCCCGGCCGGCCC",
"AGCCGACCAGCCGA",
"AGCGCCACCAACCA",
"AGCGCCGCGACCCG",
"AGGAAAAGGACGGC",
"AGGAAGGGGAAGGA",
"AGGACAACAGGGAC",
"AGGACCAACCAGGA",
"AGGACGAAAAGCAA",
"AGGCAAGAGCGCGG",
"AGGCCAAGGAACCA",
"AGGCCACGCCGCCA",
"AGGCCGGAAAGAGC",
"AGGCGACACGAGCC",
"AGGGAACGAAGGAA",
"AGGGCCACAACAAG",
"AGGGGAGGAGGGGA",
"AGGGGGAACCGCCA",
"CAAAACAGGAACAA",
"CAAAACCCCAAACA",
"CAAAAGGAAAACCG",
"CAAACGAAAACGCA",
"CAACACAGGGCACG",
"CAACCAGCAGGCAA",
"CAACGACCGACCAG",
"CAAGCAGCGCCGAA",
"CAAGGAAAAGGAAA",
"CACAAAAAAAACAA",
"CACAAACCGGCCAA",
"CACACCCCAGCAGA",
"CACCACGGCACCAC",
"CACCCCCCCCGCGC",
"CACCCCGGCCGAGC",
"CACCGGGAGAAGAG",
"CACGACCGCACCGA",
"CACGACGACGACAG",
"CAGAAGGAAGCGCC",
"CAGAAGGGGAAGCA",
"CAGACGCGGAGCCC",
"CAGCCAAGCCCCCC",
"CAGCCGAAGCCGAA",
"CAGCCGGCCGACAC",
"CAGCGCCGCCGCCG",
"CAGGGGAAGGGGAC",
"CAGGGGACCAGGGG",
"CCAAAAAAAAAAAA",
"CCAACAACCAACAG",
"CCAACCAGGACCAA",
"CCAACCCCCCAACC",
"CCAACCGGCCAACC",
"CCAAGAGGAGAACC",
"CCAAGCAACGGCCA",
"CCAAGCGAGCCGAA",
"CCACACCCCACACA",
"CCACCCCCCCCACC",
"CCACCGAGCGAACC",
"CCACGAGAACCGAG",
"CCAGCAGCCCCAGG",
"CCAGGGCCCCGACA",
"CCCAAGGACCAGGA",
"CCCAGAGAGCACAC",
"CCCAGGCAAGAGGG",
"CCCCAAGGAACCCC",
"CCCCCCAACCCCCC",
"CCCCCCCCCCCCCCCC",
"CCCCCCCCCCCCCCCCCCCC",
"CCCCCCCCCCCCCCGGCGGC",
"CCCCCCCCCCCGGCGC",
"CCCCCCCCCGAGCA",
"CCCCCCCCCGGCCCCCCCCC",
"CCCCCCCCGCCGCCCCCCCC",
"CCCCCCCCGGGGCCCCCCCC",
"CCCCCCCGGCCCCCCC",
"CCCCCCGGCGGCGGCCCCGG",
"CCCCCCGGGCGGCGGG",
"CCCCCGCGCCGGGGCCGCCC",
"CCCCCGCGGGGGCCCG",
"CCCCCGGCCCCCCGGCCCCC",
"CCCCCGGCCCGCCCCGCCCG",
"CCCCCGGGCCGGCCGG",
"CCCCCGGGGGGCCCCG",
"CCCCCGGGGGGGGCCC",
"CCCCGCCCCGGGGCGGGCCC",
"CCCCGCCGCCCCGCCCGGGC",
"CCCCGCCGCCGCCGCCCCGG",
"CCCCGCCGGGGCCGCGGCGC",
"CCCCGCGCGGGGGCCC",
"CCCCGCGGCGGCGGCGCGGC",
"CCCCGCGGCGGGCCGGGCCG",
"CCCCGCGGGGCCCCCCCCGG",
"CCCCGCGGGGGGCGCCCCCC",
"CCCCGGCCCCCCCCGGCCCC",
"CCCCGGCCCCCGCCGCCGGG",
"CCCCGGCCCCGGCCCGGGGG",
"CCCCGGCGCCCGGCGCGGGG",
"CCCCGGCGGCGGCCCGGGGC",
"CCCCGGGCCCGCCCCGCGGC",
"CCCCGGGCCGCGGGGCGGCC",
"CCCCGGGGCGGCGCCGGCGC",
"CCCCGGGGCGGCGGGG",
"CCCCGGGGGCGGCGGG",
"CCCGCCCCCCGCCCCC",
"CCCGCCCCCCGCCGCC",
"CCCGCCCCCCGCCGGC",
"CCCGCCCCGCCGCCCCGCCC",
"CCCGCCCCGGGGGCCG",
"CCCGCCCGCCCCCCGC",
"CCCGCCGCGCCGCGGCGCGC",
"CCCGCCGCGGCGGCGGCGCC",
"CCCGCCGGCCGACA",
"CCCGCCGGGCCCGCCG",
"CCCGCGCCCGGGCGGGCGCC",
"CCCGCGCCGCCGGGGGGCGC",
"CCCGCGCCGGCGGGCG",
"CCCGCGCCGGGCGGGC",
"CCCGCGCGCGGGCCCC",
"CCCGCGCGGGCGCGCC",
"CCCGCGCGGGCGCGGG",
"CCCGCGGCCGGCCGGCGGCG",
"CCCGCGGCCGGGGCCGGCGC",
"CCCGCGGGCGGCCCGGGCGG",
"CCCGCGGGCGGGCCCG",
"CCCGCGGGGGGGGCGCGCCG",
"CCCGGCCCCCCCCGGCCCGC",
"CCCGGCCCCCCGGCCC",
"CCCGGCCCCCCGGCGG",
"CCCGGCCGGCCCCCCGCCGC",
"CCCGGCCGGCCCGCGCCCCC",
"CCCGGCCGGCGCCGCGGCCC",
"CCCGGCGCGGCGCGCCGGCG",
"CCCGGCGGCCCGCCGCCCGG",
"CCCGGCGGCCGGCCCC",
"CCCGGGCCCCGGCCCG",
"CCCGGGCCCGCGGGCGGGCG",
"CCCGGGCGCCCGGGCC",
"CCCGGGCGCGCGGGCCCGCG",
"CCCGGGCGGCCCGCCC",
"CCCGGGGCCCCCCGGGGCCC",
"CCCGGGGCCGGGCCGC",
"CCCGGGGCCGGGGCCC",
"CCCGGGGCCGGGGCCCGGGC",
"CCCGGGGGGCCCCGGGGGGC",
"CCGACCAGCCAAAC",
"CCGACCCGCCGCCG",
"CCGAGAAAAGAGCC",
"CCGCCCCCCCCCCCCCCCCG",
"CCGCCCCCCCCCCCCCCGCC",
"CCGCCCCCCCCCCCCCCGGC",
"CCGCCCCCCGCCGCGG",
"CCGCCCCCGCGCGCGC",
"CCGCCCCCGGCCCCCG",
"CCGCCCCGGCCCCGCC",
"CCGCCCCGGCGGGGCGGGCG",
"CCGCCCGCCCGCGCGG",
"CCGCCCGCCGCCCGCG",
"CCGCCCGCGGGGCGCG",
"CCGCCGCCCGCGCCCC",
"CCGCCGCCGCCCCGCCGCCG",
"CCGCCGCCGCCGCA",
"CCGCCGCCGGGGCCGCCGCC",
"CCGCCGCGGCCCAG",
"CCGCCGCGGGCGCCCC",
"CCGCCGGCCGCCCG",
"CCGCCGGCCGGCCGGCCGCC",
"CCGCCGGCCGGGGCCGGCCG",
"CCGCCGGCGGCGGCCGCCGC",
"CCGCCGGGGGCGGCCG",
"CCGCGACCGAAGCC",
"CCGCGCCCCGCCGCCGGCCG",
"CCGCGCCCCGCGCCGC",
"CCGCGCCCGCGGGCCCGCGG",
"CCGCGCCCGCGGGGGGCCGC",
"CCGCGCCGCGCGCGCCCGGG",
"CCGCGCGGGCCGCGGC",
"CCGCGCGGGGGGGGCGCGCC",
"CCGCGGCCCCGGCGCC",
"CCGCGGCCGCGCCCCG",
"CCGCGGCCGCGGCGCGCGCC",
"CCGCGGCCGGCCGGCCGGCG",
"CCGCGGCCGGCGCCGG",
"CCGCGGCGCCCCGCGGCGCC",
"CCGCGGCGGCGGCGCC",
"CCGCGGCGGCGGCGGCCCCC",
"CCGCGGCGGCGGCGGCCGCC",
"CCGCGGCGGGGCGGCC",
"CCGCGGGCCGGGGCCC",
"CCGCGGGCGCGCGGGCCCGC",
"CCGCGGGCGGGCCCGC",
"CCGCGGGCGGGCCCGCGGGC",
"CCGCGGGGCGCCGGGC",
"CCGGCCCCCCCCGGCC",
"CCGGCCCCCCCCGGGC",
"CCGGCCCCCCGGCC",
"CCGGCCCCGCCGCCCCGGCG",
"CCGGCCCCGGCCCCCCCCGC",
"CCGGCCCCGGCCGCGC",
"CCGGCCCCGGGGCCCCGGCC",
"CCGGCCGCCGCCGGCC",
"CCGGCCGGCCCCGGCCGGCC",
"CCGGCCGGCCCGGGGCCCCC",
"CCGGCCGGCCGGCCGGCCGG",
"CCGGCCGGGGGGCCGGGCGC",
"CCGGCGCCGCGGGCCCCCCG",
"CCGGCGGCCCGGGGGCCGCG",
"CCGGCGGCCGCCGGGCGGGG",
"CCGGCGGGGCCCGGGC",
"CCGGCGGGGCGCCGGG",
"CCGGCGGGGCGGCCGG",
"CCGGGCCCCCCCCCCCCGGC",
"CCGGGCCCGCGGGCCC",
"CCGGGCCCGGGCCGCCCGCC",
"CCGGGCCGGCCGGGCC",
"CCGGGCGCGCGGGCCC",
"CCGGGGCCCCCCGGGG",
"CCGGGGCCCCGGGG",
"CCGGGGCCCCGGGGCC",
"CCGGGGCCCCGGGGGG",
"CCGGGGCCGCCCCGCCGGGG",
"CCGGGGCCGCCGGGGG",
"CCGGGGCCGGGGCA",
"CCGGGGCCGGGGCCGC",
"CCGGGGCGCGGCGCGGGGCC",
"CCGGGGCGGCGGGGCCGCCG",
"CCGGGGCGGGGGGCGGGGCC",
"CCGGGGGCCCCGGGGGCCGG",
"CCGGGGGCCGCCGCCGGGCG",
"CCGGGGGCCGGGGCCCGGCC",
"CCGGGGGCCGGGGGCG",
"CCGGGGGGGGGGGGGGGGCC",
"CGAACAACAACCCG",
"CGAACGCAGAGAGG",
"CGAAGCCCCGAAGC",
"CGACCAACCAACGC",
"CGACCCGGCCCAGC",
"CGAGACGCGGCGCA",
"CGAGCGGGCAACGG",
"CGAGGCCCGCAGAC",
"CGCAACGCGAGAAA",
"CGCAACGGCAACGC",
"CGCAAGGCGGCGCG",
"CGCACCCGCCACAC",
"CGCAGCCGAGGAAA",
"CGCCACCCCACACC",
"CGCCCCCCCCCCCCCCCCGC",
"CGCCCCCCCCCCCCGC",
"CGCCCCCCCCGGGCCC",
"CGCCCCCCCGGCGGCC",
"CGCCCCCCGCGGGCGCGGGG",
"CGCCCCCGGGCCCCCGGCCC",
"CGCCCCGCCGCCCCGC",
"CGCCCCGCCGGCGGCG",
"CGCCCCGCGAAGAC",
"CGCCCCGCGGCCGCCGCCCG",
"CGCCCCGCGGCGCCCG",
"CGCCCCGCGGGGCGCCCCGC",
"CGCCCCGCGGGGCGCG",
"CGCCCCGGCCCCGCGG",
"CGCCCCGGGGCCCCGC",
"CGCCCCGGGGGGCCCCGCCG",
"CGCCCGCCGCCGGCGG",
"CGCCCGCGGGCCCGCGGGCG",
"CGCCCGCGGGCGCCCGGGCG",
"CGCCGAAAAGCCGA",
"CGCCGCCCCGCCGCGCCGGC",
"CGCCGCCCGGCCGGCC",
"CGCCGCCGCCGCCGGGGGGG",
"CGCCGCCGCGGCGCCGCCCC",
"CGCCGCGCCGCGCCGCCGCG",
"CGCCGGCCAACAAG",
"CGCCGGCCCCCCGGCC",
"CGCCGGCCCGGCGCGC",
"CGCCGGCCGCCGCCGGCCGC",
"CGCCGGCCGGCCGGCC",
"CGCCGGCCGGCCGGCCGCGG",
"CGCCGGCCGGGGCCGGCCCC",
"CGCCGGCGCCCCGCGGCCGC",
"CGCCGGCGCGCCGGGC",
"CGCCGGCGCGGCGGCGGCGC",
"CGCCGGGCCCGGCCCCGGCC",
"CGCCGGGCCGCGCCGGCGCC",
"CGCCGGGCCGGGCCGGGGCC",
"CGCCGGGCCGGGCGGG",
"CGCCGGGCGGCCCCCG",
"CGCCGGGGCCGCGGGG",
"CGCCGGGGCCGGGCGCGGCC",
"CGCCGGGGGCGGGCCC",
"CGCGAAGGAAGCAG",
"CGCGCACAGCGAGG",
"CGCGCCCCGCCGCCCCGGCC",
"CGCGCCCCGGCCCCGGCGCC",
"CGCGCCCCGGGCAC",
"CGCGCCCGCCCCCCGC",
"CGCGCCCGCCGCGCCGGGCG",
"CGCGCCCGGCCGGCCC",
"CGCGCCCGGGCCGGGG",
"CGCGCCGCGCCGCGCCGCGC",
"CGCGCCGCGGCCGGCGCCGC",
"CGCGCCGGCGCCCGGC",
"CGCGCCGGGGGCGCCG",
"CGCGCGCGCGCGCGCGGGCC",
"CGCGCGCGCGGCGCGC",
"CGCGCGCGGGGGCGGG",
"CGCGCGGCCCGCCCCCGCGC",
"CGCGCGGCGCGCGGCC",
"CGCGCGGGCCCGGGCGCGCC",
"CGCGCGGGGCGCCCGGGCGG",
"CGCGGCCCCCCCCCCG",
"CGCGGCCCCCCCCGGCGGCC",
"CGCGGCCGCCGGGGGG",
"CGCGGCCGCGCGCGCC",
"CGCGGCCGCGCGGGCC",
"CGCGGCCGCGGCCGGG",
"CGCGGCCGCGGGGGCCCGGC",
"CGCGGCCGGCCCCCGG",
"CGCGGCCGGCGCGCGG",
"CGCGGCCGGGGCCGGG",
"CGCGGCGCCGCGGCGC",
"CGCGGCGCGCCGCGCGGCGC",
"CGCGGCGGCCCGGCGGGGGC",
"CGCGGCGGCGCCGCGGCGGC",
"CGCGGCGGGGCGGCGC",
"CGCGGGCCCGCGGGCGGGCG",
"CGCGGGCGCCCGCGCG",
"CGCGGGCGCCCGGGCG",
"CGCGGGCGCGCGCGCG",
"CGCGGGCGGGCGCGCG",
"CGCGGGGCCCCGGGGC",
"CGCGGGGCCGGGGCGC",
"CGCGGGGCGCCGCGGGGCGC",
"CGCGGGGGCCGCCGGC",
"CGCGGGGGGCGGGGCGGGCC",
"CGCGGGGGGGGGGGGCCGCG",
"CGCGGGGGGGGGGGGGGGGC",
"CGGAACAACCCAAC",
"CGGAACCGGCCGGA",
"CGGCAAAAAACGGC",
"CGGCACCAACCACG",
"CGGCACGGACGGGC",
"CGGCCAAAACCGGC",
"CGGCCAACCGGCCG",
"CGGCCCCCCCCCCGCC",
"CGGCCCCCCCCCCGGCGCCG",
"CGGCCCCCCCCCGCGC",
"CGGCCCCCCGCGCGGG",
"CGGCCCCCGCCGGGCGCGGC",
"CGGCCCCCGGCCCCGGCCGC",
"CGGCCCCGGCCCCGGC",
"CGGCCCCGGCCGGCCCCGGC",
"CGGCCCCGGCCGGCGC",
"CGGCCCCGGCGGCCCGGGGC",
"CGGCCCCGGGGGGGCGGCCC",
"CGGCCCGCCGCCCCCGCCGC",
"CGGCCCGGCCGCCCGCCCCG",
"CGGCCCGGGGGCCGGGGGCG",
"CGGCCGCCCCCCGGCC",
"CGGCCGCCCCGCCGCCCGGC",
"CGGCCGCCCCGGCGCC",
"CGGCCGCGCCCGGGGG",
"CGGCCGCGCCGCGCCG",
"CGGCCGGCCCCCCGGCCGGC",
"CGGCCGGCCCGCGGCG",
"CGGCCGGCCCGGGGCC",
"CGGCCGGCCGCCCGGCCGCC",
"CGGCCGGCCGCGGCGG",
"CGGCCGGCCGGCCGGC",
"CGGCCGGCCGGCCGGCCGGC",
"CGGCCGGCGCCCGGCGGGCC",
"CGGCCGGCGCCGCGGCCGGC",
"CGGCCGGCGGGGCGGCCGGC",
"CGGCGAAGAAGAAG",
"CGGCGCCCCCCGCGGG",
"CGGCGCCCCGCGGCGG",
"CGGCGCCCGGCGGCGGGGGG",
"CGGCGCCGCCCGGGGG",
"CGGCGCGCCGGGCGCG",
"CGGCGGCCGGCCGGCCGGCG",
"CGGCGGCGGCCCGGCGGCCG",
"CGGCGGCGGCCGGCGGCGGC",
"CGGCGGGGCCCGCGGGGGCC",
"CGGCGGGGGGGGGGGC",
"CGGCGGGGGGGGGGGGCGGG",
"CGGGAAGCCGAAGG",
"CGGGAAGGAAGGGA",
"CGGGCCCAAGGAGG",
"CGGGCCCCGGCCCCGC",
"CGGGCCCGCCCGGGCC",
"CGGGCCCGCCCGGGCCCGGG",
"CGGGCCGGCCCCCCCCGGCC",
"CGGGCCGGCCGGGGCC",
"CGGGCCGGGCCCCCGC",
"CGGGCCGGGCCGGGCCGGGC",
"CGGGCCGGGCGGGGCCGGCC",
"CGGGCCGGGGCCGGCCGCCG",
"CGGGCCGGGGCCGGGC",
"CGGGCCGGGGCGGCCCCCCG",
"CGGGCCGGGGGCCGGGGGGG",
"CGGGCGCCCGCCCGCGCGGG",
"CGGGCGCCCGGCCCCG",
"CGGGCGCCGCGCCGGG",
"CGGGCGCCGGGGCCGC",
"CGGGCGCGGGCGCGGG",
"CGGGCGGCGCCGCGGC",
"CGGGCGGCGGGGCGCC",
"CGGGCGGCGGGGGGCGGCGG",
"CGGGCGGGCCCGGCGG",
"CGGGCGGGCGCGGGCGCGCC",
"CGGGGACAACAGGG",
"CGGGGCAACGGGGC",
"CGGGGCCCGCCCGCCG",
"CGGGGCCGCCGCGGCC",
"CGGGGCGCCGCCGCCGCCCC",
"CGGGGCGCGGCGCGGGGCGG",
"CGGGGCGCGGCGCGGGGGGC",
"CGGGGCGGCGGCGCGG",
"CGGGGCGGCGGGGC",
"CGGGGGCCCCCCCCGG",
"CGGGGGCCGCGCGCGG",
"CGGGGGCCGCGCGGCCGGCG",
"CGGGGGCGCCCGGCCGGGCC",
"CGGGGGCGCGGGCGCCCGCC",
"CGGGGGGCCGCGGGGCGCCG",
"CGGGGGGCCGGGGGGC",
"CGGGGGGCGCCCGCGC",
"CGGGGGGCGGGCCGGC",
"CGGGGGGGCCCCGGGGGGGC",
"CGGGGGGGCCCGGCCCGCGC",
"CGGGGGGGGCCGGGGGGGCG",
"CGGGGGGGGCCGGGGGGGGC",
"CGGGGGGGGGGGGCCC",
"CGGGGGGGGGGGGGCC",
"CGGGGGGGGGGGGGGC",
"CGGGGGGGGGGGGGGGGGGC",
"GAAAAAAAAAAAAG",
"GAAAAAAAAGCCAC",
"GAAAAGGAAAAGAA",
"GAAAAGGAAGGAAA",
"GAAAGGAGCGAAAC",
"GAAAGGCGAGAGCG",
"GAACAAGAGAGGGC",
"GAACCAAAACCACA",
"GAACCCCCCCCAAG",
"GAAGGAAAAGGAAC",
"GAAGGAGGAGGAGC",
"GAAGGCCCCGGAAG",
"GACAACCCCAACAC",
"GACACAGCAAAGCA",
"GACCAAACCCGGCA",
"GACCAAAGAAGAAA",
"GACCAACCAGCCGG",
"GACCAGGACCAGGA",
"GACCGGAAGGCGCA",
"GACCGGACCAGGCG",
"GACCGGACCGGCGA",
"GACCGGGGCCAGCC",
"GACGAAGCAGCCGA",
"GACGGCCGGAACAA",
"GAGAAAGGAACGGA",
"GAGAAGAAGAAGAG",
"GAGACACCACCGAG",
"GAGAGGAAGGAGGC",
"GAGCCCCCCCCGAG",
"GAGCGAGGAGCGAA",
"GAGGAAAGGAGGCC",
"GAGGCCGGCCGGAA",
"GAGGCGACGCGGCG",
"GAGGGAACGAAAGG",
"GAGGGCCCAAAACC",
"GAGGGGACGGCAGG",
"GAGGGGGGGGAGGA",
"GCAAACCCCAAACG",
"GCAAAGGAAAACGC",
"GCAAAGGCGAAAAG",
"GCAACAACAACGAA",
"GCAACAACGACGCC",
"GCAACCGGACGGGG",
"GCAACGCAACGACC",
"GCAACGGGGCAACG",
"GCAAGGAAAAGGAA",
"GCACAACGGCAACA",
"GCACCCCCCCCCCA",
"GCACGAAAAGCACG",
"GCACGCCAGGACCG",
"GCCAACAACAACCG",
"GCCACGGAGGAGGC",
"GCCAGAAGACCGGC",
"GCCAGCGCCGCCGC",
"GCCCAACCCCAACC",
"GCCCCAAAGCAGGA",
"GCCCCCACCACCCA",
"GCCCCCCCCCCCCCCCCGCG",
"GCCCCCCCCCCCCCCG",
"GCCCCCCCCCCCCG",
"GCCCCCCGCGGCGCCCCCCG",
"GCCCCCCGGCCCCCCG",
"GCCCCCGCCCCGGCCGCGGC",
"GCCCCCGGGCGCGCGC",
"GCCCCGAAGCCCCG",
"GCCCCGCCCCCCCCGC",
"GCCCCGCCCGCCCCCGGCGG",
"GCCCCGCCGGGGGGCCGGCG",
"GCCCCGGCCGCGGGGG",
"GCCCCGGCCGGCCCCG",
"GCCCCGGGGCCCCCCC",
"GCCCCGGGGGGCCCCG",
"GCCCGCCCAACCGA",
"GCCCGCCCGCGCGCCCGCGG",
"GCCCGCGCGGGGCCCC",
"GCCCGCGGCGGCGGCGGGCC",
"GCCCGCGGGGGGGGCC",
"GCCCGGCCCCCCCCGGCCCC",
"GCCCGGCCCCCCCCGGCCCG",
"GCCCGGCCCGGCCCGGCCCG",
"GCCCGGCCCGGCCCGGCCGG",
"GCCCGGCCGCGGCCGGGGCC",
"GCCCGGCGCGGGGGGCGCCG",
"GCCCGGCGGCCCCCGC",
"GCCCGGGGCCCCGGGGCCCG",
"GCCCGGGGCCCGCGGCCCCG",
"GCCCGGGGCCGGGGCCCGCC",
"GCCCGGGGCCGGGGCCCGCG",
"GCCCGGGGCGGGCCGC",
"GCCCGGGGGGGGCGGG",
"GCCGAAAAGCCGAG",
"GCCGAACAGCAGCA",
"GCCGCCCCCCGCCGGG",
"GCCGCCCCGCCGCCGG",
"GCCGCCCCGGCCGCGC",
"GCCGCCCGCGCCGCCGCCGC",
"GCCGCCCGGCCGGCGGGCCG",
"GCCGCCGCCCCCCCCGCCGC",
"GCCGCCGCCCGGCGGC",
"GCCGCCGCCGCGGGCC",
"GCCGCCGCCGGCCGCCGCCG",
"GCCGCCGCGCCGCGGG",
"GCCGCCGGCCGCCGCG",
"GCCGCCGGCCGGCCGGCCGC",
"GCCGCCGGGGCCGCCG",
"GCCGCCGGGGCCGCGCCGCG",
"GCCGCGCCCCCCCCGCGCCG",
"GCCGCGCCCCGGGGGGCGCG",
"GCCGCGCGCGGGCGCGCCCG",
"GCCGCGGCCGGGCGCGCGGC",
"GCCGCGGGGCGGCCCGCGGC",
"GCCGGCCCCCCCCGGCCCGC",
"GCCGGCCCCCCCCGGCCGGG",
"GCCGGCCCCCCCGGCGCGCG",
"GCCGGCCCCGGCCCCGGCCG",
"GCCGGCCCGCCGGGGG",
"GCCGGCCCGGGGGCCCCGCC",
"GCCGGCCGCGGCGCCGGCCG",
"GCCGGCCGCGGGCGGGCCCC",
"GCCGGCCGGCCGGCCG",
"GCCGGCCGGCGGCGGCCGGC",
"GCCGGCCGGGGCCGGCCGCC",
"GCCGGCCGGGGGCCGCCCGG",
"GCCGGCGGCGGGGGCGGCGG",
"GCCGGGCCGGCCGGGCCGGG",
"GCCGGGCCGGGCCCCGGCGC",
"GCCGGGCCGGGGCC",
"GCCGGGCGCGCGGGCCCCGG",
"GCCGGGGCCCCCCGGGGCCG",
"GCCGGGGCCGGCCGGGGCCG",
"GCCGGGGGGCCCCGGGGGGC",
"GCCGGGGGGGGCGGGGCGCC",
"GCCGGGGGGGGGGCCG",
"GCGACACAGCCAGC",
"GCGACCAGCGCCGA",
"GCGACCAGGACCAG",
"GCGAGCACCGCGAC",
"GCGAGGAGCGCACC",
"GCGCAGAAAGAGAC",
"GCGCCCCCCCCGCGCG",
"GCGCCCCCCGCGGGGGGCCC",
"GCGCCCCCGCCAAC",
"GCGCCCCCGCGGCGCG",
"GCGCCCCGCGGCGCCCCGCG",
"GCGCCCGCCCGCCCGG",
"GCGCCCGCGCCGGGCG",
"GCGCCCGCGGCGCCCGCGGC",
"GCGCCCGCGGCGCCGG",
"GCGCCCGCGGGGGCGGCGGC",
"GCGCCCGGCGGGGCGGCCGC",
"GCGCCCGGGGGGGGCC",
"GCGCCGCCCCGCCGCG",
"GCGCCGCCCCGCGGGC",
"GCGCCGCCGCCGCCGCCGCC",
"GCGCCGCCGCGGCGCC",
"GCGCCGCGCGGCCCCCCCCG",
"GCGCCGCGGCGCCGCG",
"GCGCCGGCCCCCCGGCCGCC",
"GCGCCGGCCGGCCGGCCGCG",
"GCGCCGGCGCGCCCGG",
"GCGCCGGCGGCCCCGG",
"GCGCCGGGCGCCGGCCGCGG",
"GCGCCGGGCGGCGGGCCGCC",
"GCGCCGGGGGGCCGGGGGGC",
"GCGCGCCGGCGCCGGG",
"GCGCGCCGGCGCGCGG",
"GCGCGCGCGCGCCCGCGGGC",
"GCGCGCGCGCGCGCGC",
"GCGCGCGCGGCGCGCG",
"GCGCGCGGACACCG",
"GCGCGCGGCCCCGCCG",
"GCGCGCGGGCGCGGGCCGCC",
"GCGCGCGGGGCGCGGC",
"GCGCGGCCCGGGGCCCGGCG",
"GCGCGGCCGGCGCGGC",
"GCGCGGCCGGGGCCCGGCGC",
"GCGCGGCCGGGGGGGGCGCG",
"GCGCGGCGCGCCGCGG",
"GCGCGGCGGCCGGGGCCGGG",
"GCGCGGGCCCCGCGGC",
"GCGCGGGCGCGCGCCC",
"GCGGAAAAAAGGAC",
"GCGGAAGAAGAAAA",
"GCGGACGGCAGGCG",
"GCGGCCCCCCCCCCGG",
"GCGGCCCCCCCCGCCC",
"GCGGCCCCCCCCGGGCGCCG",
"GCGGCCCCGGCGCCGG",
"GCGGCCCCGGGGGGCCCCCC",
"GCGGCCCGGCCCGGCG",
"GCGGCCGGCACGCG",
"GCGGCCGGCCCCGGCCGGCG",
"GCGGCCGGCCGGCCGGCCGC",
"GCGGCCGGCGGCGGCCGGCG",
"GCGGCCGGGCGGCCGCCGCG",
"GCGGCGAAAACGGA",
"GCGGCGCCCCGCGGCG",
"GCGGCGCCGCGGCGCC",
"GCGGCGCGGCGCGGCG",
"GCGGCGCGGCGCGGCGCGGG",
"GCGGCGCGGCGCGGCGGGCG",
"GCGGCGCGGCGGCCGCGGCC",
"GCGGCGGCCCCGGCGGCGGG",
"GCGGCGGCCGGCCCCGCCCG",
"GCGGCGGCGGCCCCGC",
"GCGGCGGCGGCGCCGG",
"GCGGCGGCGGGGCGGCGGCG",
"GCGGCGGGGCCGGCCGGGGC",
"GCGGCGGGGCGGCG",
"GCGGGAGAAGAGGG",
"GCGGGCCCCCCCCCCGGGCG",
"GCGGGCCCCGGCCCCGCCGC",
"GCGGGCCCGCCCCGCG",
"GCGGGCCGCGGCCGCG",
"GCGGGCCGGCCGGCCG",
"GCGGGCCGGGGCCGGCCGGC",
"GCGGGCCGGGGCCGGG",
"GCGGGCGCCCCCGCGG",
"GCGGGCGCCGCGGGCC",
"GCGGGCGCCGGGGCCGGCGG",
"GCGGGCGCGCGGGCGG",
"GCGGGCGGGGCGGGCGGGCG",
"GCGGGGCCGCCGGGCG",
"GCGGGGCCGGGGCG",
"GCGGGGCGGCGGGGCG",
"GCGGGGCGGCGGGGCGGCGC",
"GCGGGGGCCGGGGGCG",
"GCGGGGGCGGGGGGGCGGCC",
"GCGGGGGGGGCCGCGCCGCC",
"GCGGGGGGGGGGGGCG",
"GCGGGGGGGGGGGGCGCGGC",
"GGAAAAGAAGAAAA",
"GGAAGCGGCGAAGG",
"GGAAGGACCAGGAA",
"GGACAACAACAACA",
"GGACACCCAAAACC",
"GGACCAGGACCAGA",
"GGACCCAGGACCCA",
"GGACCCCACGGACG",
"GGACGCCGCGCCAA",
"GGAGAGCCCGGCCA",
"GGAGGAAGGACAGC",
"GGCAAAAAAAAAAC",
"GGCACGGCGCAAAC",
"GGCCAAAGAAGAAA",
"GGCCAACGGCCGCA",
"GGCCCAGGACCCGG",
"GGCCCCCCCCCCCCCCCCCC",
"GGCCCCCCCCCCCCCCCCGG",
"GGCCCCCCCCCCCCGG",
"GGCCCCCCCCCCGCCCCGGC",
"GGCCCCCCCCGGCCGGGCGG",
"GGCCCCCCCGGCGCCGGCCG",
"GGCCCCCCGGCCGGGCGGGG",
"GGCCCCCGGCCCCCCG",
"GGCCCCCGGCCCCCGC",
"GGCCCCCGGGGCCGGGGCCC",
"GGCCCCGCGCGCCCCG",
"GGCCCCGCGGCCGCCG",
"GGCCCCGGGCGCGGGCCGCC",
"GGCCCCGGGGCCCCGG",
"GGCCCCGGGGGCGGGGGGGG",
"GGCCCCGGGGGGCCCCGGCC",
"GGCCCCGGGGGGCGGG",
"GGCCCGACGCGAGC",
"GGCCCGCCCCGCGGCG",
"GGCCCGCCCGCGGGCGCGCC",
"GGCCCGCCGCCGCCCG",
"GGCCCGCCGGGGCGGGCGCC",
"GGCCCGGCCGCGGCGC",
"GGCCCGGCCGGCCGGC",
"GGCCCGGCGCGCCCCCGCCC",
"GGCCCGGGGCCCGCGC",
"GGCCCGGGGGGCCCGG",
"GGCCGCCCCCCCCCCGCCGG",
"GGCCGCCCCGCGCGGC",
"GGCCGCGCGGGGCGCC",
"GGCCGCGGGGCGCCGGGGCG",
"GGCCGGACAAAAGG",
"GGCCGGCCGCCGCCGGCCGC",
"GGCCGGCCGCCGCCGGCCGG",
"GGCCGGCCGGGGCCGGCCGG",
"GGCCGGCCGGGGGGCG",
"GGCCGGCGCCGCGGGG",
"GGCCGGCGCGGCCCGCCGCC",
"GGCCGGGCCGGGCCGGCGGC",
"GGCCGGGGCCCCGGGGCGCG",
"GGCCGGGGGGCCGGCC",
"GGCCGGGGGGCCGGGCCCGG",
"GGCGCCCCCCGCGCCGCGGG",
"GGCGCCCGGGCCCGGG",
"GGCGCCCGGGGCCCGG",
"GGCGCCGCCCGGCCGG",
"GGCGCCGCCGCCGCGG",
"GGCGCCGCGCGCGCGC",
"GGCGCCGCGGCGCCGCGGCC",
"GGCGCCGCGGGGCGCCGCGG",
"GGCGCCGGCGCCCGCGCCGG",
"GGCGCCGGCGGGGGCG",
"GGCGCGCCCGCCGCCC",
"GGCGCGCCCGGGGGCC",
"GGCGCGCCGCCCCGCCGCGC",
"GGCGCGGCCCCCCGCGCCCC",
"GGCGCGGCCCCCGGCG",
"GGCGCGGCGCCGGGGC",
"GGCGCGGCGGCGGCGC",
"GGCGGCCCCGGCCCCCCGGC",
"GGCGGCCCGGGGCCCGGCCC",
"GGCGGCCGGCCCCGGCCGGC",
"GGCGGCCGGCGCCCGC",
"GGCGGCCGGCGGCGCGGGCG",
"GGCGGCCGGGGCCCCGGGGC",
"GGCGGCCGGGGCCGGG",
"GGCGGCGCGGGCCCCC",
"GGCGGCGGCCGCCCGCCCCG",
"GGCGGCGGCGGCGGGG",
"GGCGGCGGGGCGCCGGCGCC",
"GGCGGCGGGGCGGCGG",
"GGCGGCGGGGGGCCCC",
"GGCGGCGGGGGGGGCGGCGG",
"GGCGGGCCCGGGCCCGGGCC",
"GGCGGGCGCCGCGGGC",
"GGCGGGCGCGCCCGCCCGCC",
"GGCGGGCGGGCGCGGG",
"GGCGGGGCCGGGGCGG",
"GGCGGGGCGGGGCCGCGCGG",
"GGCGGGGCGGGGCGGGGCGG",
"GGCGGGGGCGGGGCCCCGGC",
"GGCGGGGGGCGCGGGGGGGC",
"GGCGGGGGGGCCCCGGGGGG",
"GGCGGGGGGGGCGGGGCGCG",
"GGCGGGGGGGGGGGGC",
"GGGACAACAACAAC",
"GGGACCAGGGCAAG",
"GGGAGCACAGGAAG",
"GGGCCCCGCCCCCCCGCGCG",
"GGGCCCCGCGGCCGCG",
"GGGCCCCGGCCGGCCCCGGG",
"GGGCCCCGGCGCCCCC",
"GGGCCCCGGGGGGCCC",
"GGGCCCCGGGGGGCCCCGGG",
"GGGCCCCGGGGGGG",
"GGGCCCGCCCGGGCGC",
"GGGCCCGCGCGCCCGC",
"GGGCCCGCGGGCCCGCCGGC",
"GGGCCCGCGGGCCGGG",
"GGGCCCGCGGGCGGGCCCGG",
"GGGCCCGCGGGCGGGCGCGG",
"GGGCCCGGCCCGGG",
"GGGCCCGGGGGGCCCGGCCC",
"GGGCCGGCCCCCCCCGGCCC",
"GGGCCGGCCCCGGCCGGGGC",
"GGGCCGGCCGGCCGGCCGGG",
"GGGCCGGCCGGCCGGG",
"GGGCCGGCCGGCCGGGCCCC",
"GGGCCGGGCCAAGC",
"GGGCCGGGCCGGGCCGGCGC",
"GGGCCGGGCGCGCCCCGGGG",
"GGGCCGGGGCGGGCGG",
"GGGCCGGGGCGGGG",
"GGGCCGGGGGGCCGGG",
"GGGCGACAGCAGAG",
"GGGCGCCCCCCCGGCCCCCC",
"GGGCGCCCCGGCCCCG",
"GGGCGCCCGGGCCCGCGCGG",
"GGGCGCCCGGGCCCGG",
"GGGCGCCCGGGGGGGGCGCC",
"GGGCGCGCCCGGGCGCGGCC",
"GGGCGCGCCGGGGCGGGGCG",
"GGGCGCGCGCGCCCGCCCGC",
"GGGCGCGCGGGCGCCCGGGC",
"GGGCGCGGCGGCGGCG",
"GGGCGCGGGGCGCGGC",
"GGGCGCGGGGGCCCCCCCGG",
"GGGCGGCCCCCCGGCC",
"GGGCGGCCCGCCCCGG",
"GGGCGGCCGGCGCCGGCGCG",
"GGGCGGCGGGCCGGCG",
"GGGCGGCGGGGGGCGGCGGG",
"GGGCGGGCCCGCCCGGGCGC",
"GGGCGGGCGCGGGGGC",
"GGGCGGGCGGGCGCCCGCGC",
"GGGCGGGGCCGCGCGG",
"GGGCGGGGCGCCGA",
"GGGGACAACGGAAG",
"GGGGCAAAACGGGG",
"GGGGCCCCGGGCGCGC",
"GGGGCCCCGGGGCCCCGGGG",
"GGGGCCCGCGGCCGCC",
"GGGGCCCGGCGGCCGGCGGG",
"GGGGCCCGGGGCGGCC",
"GGGGCCGCCCGGCCCGCCCC",
"GGGGCCGCCGCCGGGG",
"GGGGCCGCCGGGCCCCCGCG",
"GGGGCCGCGCGGCGGG",
"GGGGCCGCGGGCGCGCGGCG",
"GGGGCCGGCCGCGGGGCGCC",
"GGGGCCGGGCCGGGCCGGGG",
"GGGGCCGGGGCCGGCCGCCC",
"GGGGCCGGGGGGCCGG",
"GGGGCCGGGGGGGGCCGGGG",
"GGGGCGCCGGCCGGCG",
"GGGGCGGCCGGCCGGC",
"GGGGCGGCGCCGGCGC",
"GGGGCGGCGGCGGCCCCCCC",
"GGGGCGGCGGGGGGGC",
"GGGGCGGGCCGCGGCC",
"GGGGCGGGGGGCGCCG",
"GGGGGCGGCCGGCCGG",
"GGGGGCGGGGCGGGGG",
"GGGGGGCCGGCCGCCC",
"GGGGGGCCGGGGCCGGGGGG",
"GGGGGGCCGGGGGGCG",
"GGGGGGCGCCGCGGGG",
"GGGGGGCGGCGGGGGG",
"GGGGGGGCCCGGCCCG",
"GGGGGGGCCGGGGGGG",
"GGGGGGGGACAAAG",
"GGGGGGGGCCGGGGGGGCCG",
"GGGGGGGGGCCGGGGGGGGG",
"GGGGGGGGGGCCGGGGGGGG",
"GGGGGGGGGGGCCGGC",
"GGGGGGGGGGGGAG",
"GGGGGGGGGGGGGGGG",
"GGGGGGGGGGGGGGGGGGGG",
"END"
};

int main() {
  gen("AGTCAGTCAGTCAGTC", "A", "AGTCAGTCAGTCAGTC");
  gen("CAAAAAAAAAAAAAAAAC", "G", "CGGGGGGGGGGGGC");
  gen("CAAAAAAAGGGGGAAAAC", "CT", "CGGGGGAAAAAAGC");
  gen("CAAAAAAAGGGGGAAAAC", "TG", "CGGGGGAAAAAAGC");
  gen("CAAAAAAAGGAC", "GA", "GAGGGGAAGC");
  gen("CAGGGGGAAATAC", "AC", "CGGGGGAAAAGTCAAAGC");
  gen("CAAAAAAAGAAAAC", "TC", "CGGGGGAAAGGGGGAAAAGC");
  gen("CAAAAAAAGGAAAAC", "GT", "CGGGGGAAAAAGAAACAGC");
  gen("CAAAAAAAGGGAAAAC", "AG", "GAGAGACGGGGGAACAACAAGC");
  gen("CAAAAAAAGGGGAAAAC", "CA", "CAACGGGGAAAAAAGC");
  gen("CAAAAAAAGGAC", "CAT", "GAGGGGAAGC");
  gen("CAGGGGGAAATAC", "AGA", "CGGGGGAAAAGTCAAAGC");
  gen("CAAAAAAAGAAAAC", "TTG", "CGGGGGAAAGGGGGAAAAGC");
  gen("CAAAAAAAGGAAAAC", "CCA", "CGGGGGAAAAAGAAACAGC");
  gen("CAAAAAAAGGAC", "CATG", "GAGGGGAAGC");
  gen("CAAAAAAAGAAAAC", "GACA", "CGGGGGAAAGGGGGAAAAGC");
  gen("CAAAAAAAGAAAAC", "TACT", "CGGGGGAAAGGGGGAAAAGC");
  gen("CAAAAAAAGAAAAC", "ATTC", "CGGGGGAAAGGGGGAAAAGC");
  gen("CAAAAAAAGGAAAAC", "AAAC", "CGGGGGAAAAAGAAACAGC");
  gen("CAAAAAAAGGAAAAC", "AACA", "CGGGGGAAAAAGAAACAGC");
  gen("CAAAAAAAGGAAAAC", "AGCAT", "CGGGGGAAAAAGAAACAGC");
  gen("CAAAAAAAGGAAAAC", "AGCATA", "CGGGGGAAAAAGAAACAGC");
  string s = "A";
  for (int i = 0; i < 299; ++i) s.push_back("GGTT"[i%4]);
  gen("AAAAAAAGGTCAAA", s.c_str(), "CGGAAACAGC");
  s = "TAGGAAGGAT";
  for (int i = 0; i < 299; ++i) s.push_back("CAAC"[i%4]);
  gen("AAAAAAAGGTCAAA", s.c_str(), "CGGAAACAGC");
  s = "GGGGGGGG";
  for (int i = 0; i < 299; ++i) s.push_back("AAAA"[i%4]);
  gen("AAAAAAAGGTCAAA", s.c_str(), "CGGAAACAGC");
  for (int i = 0; string(tab[i]) != "END"; ++i) {
    tests.push_back(tab[i]);
  }
  cout << tests.size() << endl;
  for (const auto &t : tests) cout << t << endl;
}
