// Author: Adam Polak
// Greedy
#include <deque>
#include <iostream>
#include <string>
using namespace std;

int main() {
  ios_base::sync_with_stdio(false);

  int Z;
  cin >> Z;
  while (Z--) {
    int n;
    cin >> n;
    string solution;
    deque<int> blocks;
    for (int i = 0; i < n; ++i) {
      int a;
      cin >> a;
      char choice;
      if (blocks.size() < 2) {
        choice = 'r';
      } else {
        if (blocks.back() >= a && (blocks.front() < a || blocks.front() >= blocks.back())) {
          choice = 'r';
        } else {
          choice = 'l';
        }
      }
      if (choice == 'r') {
        while (!blocks.empty() && blocks.back() == a) {
          a *= 2;
          blocks.pop_back();
        }
        blocks.push_back(a);
      } else {
        while (!blocks.empty() && blocks.front() == a) {
          a *= 2;
          blocks.pop_front();
        }
        blocks.push_front(a);
      }
      solution.push_back(choice);
    }
    cout << (blocks.size() == 1 ? solution : "no") << endl;
  }
}
