#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include "ver.h"
#include <cstdio>

int main() {
  oi::Scanner in(stdin);
  int Z = in.readInt(1, 1e9);
  in.readEoln();
  while (Z--) {
    int n = in.readInt(1, 1000);
    in.readEoln();
    int sum = 0;
    for (int i = 0; i < n; ++i) {
      if (i > 0) in.readSpace();
      int a = in.readInt(1, (1 << 13));
      bool is_power = false;
      for (int k = 0; k <= 13; ++k)
        if (a == (1 << k)) {
          is_power = true;
          break;
        }
      if (!is_power)
        in.error("Not a power of two");
      sum += a;
      if (sum > (1 << 13))
          in.error("Sum is too large");
    }
    in.readEoln();
  }
  in.readEof();
  printf("OK\n");
}     
