#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <cassert>
#include <cmath>
#include <iostream>
using namespace std;

const int MAXN = 1e5;
const int MAXY = 1e9;

template<typename T>
void test(T func) {
  cout << MAXN << endl;
  for (int x = 0; x < MAXN; ++x) {
    int y = func(x);
    assert(0 <= y && y <= MAXY);
    cout << x << " " << y << endl;
  }
}

int main() {
  ios_base::sync_with_stdio(false);

  cout << 4 << endl;
  test([](double x){ return pow(0.015*(x - MAXN / 2), 3) + MAXY / 2; });
  test([](double x){ return (tan((x / (double)MAXN) * 2 - 1) + 2) / 4 * MAXY; });
  test([](double x){ return 80 * pow(0.00005 * x, 2) * (sin(0.000065 * x) + 1); });
  test([](double x){ return abs(x - MAXN / 2) / 2; });
}
