#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

void solve() {
	int n; scanf("%d", &n);
	vector<pii> v;
	int cw = 0;
	int cb = 0;
	forn(i, n) {
		int cnt; scanf("%d", &cnt);
		char c = 0; while (c != 'W' && c != 'B') c = getchar();
		v.pb(mp(cnt, c == 'B'));
		if (c == 'B') cb += cnt;
		else cw += cnt;
	}
	if (cw == 0 || cb == 0) { printf("%d\n", (int)(cw+cb)); return;}
	cb += cw;
	int ans = 0;
	int c0 = 0, c1 = 0;
	forn(ii, n) {
		int curlen = v[ii].X;
		int col = v[ii].Y;
		if (col == 0) {
			ll x = (ll)c0 * (cb-cw)-cw*(ll)c1;
			if (x % (cw-cb) == 0) {
				x /= cw-cb;
				if (x > 0 && x <= curlen) ans++;
			}
			c0 += curlen;
		} else {
			ll x = (ll)c0 * (cb-cw)-cw*(ll)c1;
			if (x % cw == 0) {
				x /= cw;
				if (x > 0 && x <= curlen) ans++;
			}
			c1 += curlen;
		}
	}
	printf("%d\n", ans);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
