#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n;

bool ok(int n, int sz) {
	ll x = n - sz * 1ll * (sz-1) / 2;
	if(x <= 0 || x % sz != 0) return false;
	return true;
}

void print(int n, int sz) {
	ll x = n - sz * 1ll * (sz-1) / 2;
	ll a = x / sz;
	cout << n << " = " << a; 
	for(ll i = a+1; i < a + sz; i++) cout << " + " << i;
	cout << endl;
}

void solve() {
	scanf("%d", &n);

	for(int sz = 2; sz * 1ll * sz <= 2ll * n; sz++) {
		if(ok(n, sz)) {
			print(n, sz);
			return;
		}
	}

	puts("IMPOSSIBLE");
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif


	int t;

	scanf("%d", &t);

	while(t--) solve();

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
