#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;

LL ans, f, n, carry, l, r, t, m;

LL get(LL x, LL l)
{
	return x * l + l * (l - 1) / 2;
}

int main()
{
	//freopen(fname"in", "r", stdin);
	//freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n;
		carry = 1;
		ans = inf;
		for (LL x = 2; x * x <= n; x++)
		{
			if (n > carry && (n - carry) % x == 0)
			{
				if (ans > x)
				{
					ans = x;
					f = (n - carry) / x;
				}
			}
			carry += x;
		}
		for (LL x = 1; x * x <= n; x++)
		{
			l = 2; r = n + 1;
			while (r - l > 1)
			{
				int m = (l + r) >> 1;
				if (get(x, m) <= n)
					l = m;
			   	else
			   		r = m;
			}
			if (get(x, l) == n)
			{
				if (ans > l)
				{
					ans = l;
					f = x;
					}
			}


		}
		if (ans == inf)
			cout << "IMPOSSIBLE";
		else
		{
			cout << n << " = ";
			for (int i = 1; i <= ans; i++)
			{
				cout << f++;
				if (i != ans)
					cout << " + ";
			}
		}
		cout << "\n";
	}
	return 0;
}


