#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <utility>
#include <queue>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define fname ""

typedef long long LL;
typedef pair<int,int> pii;

const int maxn = (int)1e6;
const LL inf = (LL)1e18;
const int mod = (int)1e9 + 7;
const double eps = 1e-9;

int test, n, k, v[maxn], c[maxn];
long long ans, d[maxn][10];

int main() {
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> test;
	while (test--) {
		cin >> n >> k;
		for (int i = 1; i <= n; ++i)
			cin >> v[i] >> c[i];
	
	    d[0][0] = 0;
	    for (int i = 1; i <= k; ++i)
	    	d[0][i] = -inf;

	    ans = -inf;

		for (int i = 1; i <= n; ++i) {
			d[i][0] = 0;
			for (int j = 1; j <= k; ++j)
				d[i][j] = max(d[i - 1][j - 1] - c[i], d[i - 1][j]);
			ans = max(d[i - 1][k] + v[i] - c[i], ans);
		}

		cout << max(ans, 0ll) << '\n';
	}

	return 0;
}
