#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "k"

#define M 200200
#define N 200
#define INF 1000000000

pair<int, int> a[M];
int n, k, d[N];

bool pos(int diff)
{
	fill(d, d + N, INF);
	d[0] = 0;
	
	for (int i = 0; i < n; ++i)
		for (int j = k; j >= 0; --j)
			if (d[j] + a[i].se <= a[i].fi - diff)
				d[j + 1] = min(d[j + 1], d[j] + a[i].se);
	return d[k + 1] < INF;
}

void solve()
{
	cin >> n >> k;
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i].fi >> a[i].se;
	}
	sort(a, a + n);
	
	if (k >= n)
	{
		cout << "0\n";
		return;
	}
	
	int l = 0, r = INF, m;
	while (l < r)
	{
		m = (l + r) / 2;
		if (pos(m + 1))
			l = m + 1;
		else
			r = m;
	}
	cout << l << "\n";
}
int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int t;
	scanf("%d\n", &t);
	for (int i = 0; i < t; ++i)
		solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}

