#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

vector<pair<int, char> > a;

int main()
{
    int tests;
    cin >> tests;
    while (tests--) {
        int n;
        cin >> n;
        a.clear();
        a.resize(n);
        int sum_w = 0, sum_b = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first >> a[i].second;
//            cerr << a[i].second << endl;
            if (a[i].second == 'W')
                sum_w += a[i].first;
            else sum_b += a[i].first;
        }

        if (sum_w == 0 || sum_b == 0) {
            cout << max(sum_w, sum_b) << "\n";
            continue;
        }

        int d = __gcd(sum_w, sum_b);
        sum_w /= d;
        sum_b /= d;

//        cerr << sum_w << " " << sum_b << endl;



        int ans = 0;
        int cur_w = 0, cur_b = 0;
        for (int i = 0; i < n; ++i) {
//            cerr << i << " " << cur_w << " " << cur_b << endl;
            if (a[i].second == 'W') {
/*                cur_w += a[i].first;
                if (cur_b % sum_b == 0 && (cur_w / sum_w == cur_b / sum_b)) {
                    a[i].first -= cur_w % sum_w;
                    cur_w = cur_b = 0;
                    ++ans;
                    if (a[i].first != 0)
                        --i;
                }*/
                int need_w = cur_b / sum_b * sum_w - cur_w;
//                cerr << need_w << endl;
                if (cur_b != 0 && need_w >= 0 && need_w <= a[i].first && cur_b % sum_b == 0 && ((cur_b / sum_b * sum_w) / sum_w == cur_b / sum_b)) {
                    a[i].first -= need_w;
                    cur_w = cur_b = 0;
                    ++ans;
                    if (a[i].first != 0)
                        --i;
                } else cur_w += a[i].first;
            } else {
                int need_b = cur_w / sum_w * sum_b - cur_b;
                //cerr << need_b << " " << cur_w << " " << sum_w << " " << sum_b << " " << cur_b << endl;
                if (cur_w != 0 && need_b >= 0 && need_b <= a[i].first && cur_w % sum_w == 0 && ((cur_w / sum_w * sum_b) / sum_b == cur_w / sum_w)) {
                    a[i].first -= need_b;
                    cur_w = cur_b = 0;
                    ++ans;
                    if (a[i].first != 0)
                        --i;
                } else cur_b += a[i].first;
            }
        }
        if (cur_w + cur_b != 0) ++ans;
        cout << ans << "\n";
    }
    return 0;
}
