#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

vector<int> a;
vector<int> g[11];

void check(vector<int> const &buf, int pos, int value) {
    if (pos == buf.size() && value != 0)
        a.push_back(value);
    if (value > 200 || pos == buf.size())
        return;
    if (value != 0 || buf[pos] != 0)
        check(buf, pos, value * 10 + buf[pos]);
    check(buf, pos + 1, value * 10 + buf[pos]);
    check(buf, pos + 1, value);
}

void dfs(int u, vector<int> &buf) {
    if (u == 0 || u == 9) {
        check(buf, 0, 0);
        return;
    }
    for (int v : g[u]) {
        dfs(v, buf);
        buf.push_back(v);
        dfs(v, buf);
        buf.pop_back();
    }
};

int main() {
    g[1] = {2, 4};
    g[2] = {3, 5};
    g[3] = {6};
    g[4] = {5, 7};
    g[5] = {6, 8};
    g[6] = {9};
    g[7] = {8};
    g[8] = {9, 0};
    vector<int> buf;
    dfs(1, buf);
    buf.push_back(1);
    dfs(1, buf);
    sort(a.begin(), a.end());
    int t;
    cin >> t;
    while (t--) {
        int k;
        cin >> k;
        int pos = lower_bound(a.begin(), a.end(), k) - a.begin();
        int ans = 500, value = 0;
        for (int i = max(pos - 1, 0); i < min((int) a.size(), pos + 1); ++i)
            if (ans > abs(a[i] - k)) {
                    ans = abs(a[i] - k);
                    value = a[i];
            }
        cout << value << '\n';
    }
    return 0;
}
