#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 300;
const int inf = 1000000000;

struct Input {
	int n;
	int l[N], r[N], h[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		forn (i, n) {
			scanf("%d%d%d", &l[i], &r[i], &h[i]);
			++r[i];
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	int d[2][N + 1][N + 1];
	int id[N + 1][N + 1];
	
	void solve () {
		{
			vi q;
			forn (i, n) {
				q.pb(l[i]);
			}
			sort(all(q));
			forn (i, n) {
				l[i] = lower_bound(all(q), l[i]) - q.begin();
				r[i] = lower_bound(all(q), r[i]) - q.begin();
			}
		}
		{
			ve<pa<int, pii> > q;
			forn (i, n) {
				q.pb(mp(h[i], mp(l[i], r[i])));
			}
			sort(all(q));
			forn (i, n) {
				h[i] = q[i].fs;
				l[i] = q[i].sc.fs;
				r[i] = q[i].sc.sc;
			}
		}
		memset(d, 0, sizeof d);
		forn (i, n) {
			int i0 = i & 1;
			int i1 = i0 ^ 1;
			forn (rb, n + 1) {
				ford(lb, rb + 1) {
					d[i1][lb][rb] = inf;
					if (l[i] >= lb && r[i] <= rb) {
						int lq = lb, rq = rb;
						if (l[i] > lb) {
							lq = id[lb + 1][rb];
						}
						if (r[i] < lb) {
							rq = id[lb][rb - 1] + 1;
						}
						for (int j = lq; j < rq; ++j) {
							if (umn(d[i1][lb][rb], d[i0][lb][j] + d[i0][j + 1][rb] + h[i])) {
								id[lb][rb] = j;
							}
						}
					} else {
						d[i1][lb][rb] = d[i0][lb][rb];
					}
				}
			}
		}
		ans = d[n & 1][0][n];
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("l.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
