#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int INF = (int) 1e6 + 10;
const int N = (int) 1e6 + 10;
pair<int, int> v[N];
int n, k, t, ans[N];

bool check(int q) {
	for (int j = 0; j <= k; ++j)
		ans[j] = (j == 0) ? 0 : INF;
	for (int i = 1; i <= n; ++i) {
		int curv = v[i - 1].fs - q, curc = v[i - 1].sc; 
		for (int j = k; j >= 1; --j)
			if (curv >= ans[j - 1] + curc) ans[j] = min(ans[j], ans[j - 1] + curc);
		ans[0] = 0;
	}
	return (ans[k] != INF);
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &t);
	for (int it = 0; it < t; ++it) {
		scanf("%d%d", &n, &k), k++;
		for (int i = 0; i < n; ++i)
			scanf("%d%d", &v[i].fs, &v[i].sc);
		sort(v, v + n);
		int l = 0, r = INF;
		while (l < r) {
			int q = (l + r + 1) / 2;
			if (check(q))
				l = q;
			else
				r = q - 1;
		}
		printf("%d\n", l);
	}
	return 0;
}