#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int n, k;
pii items[262144];
int used[262144];

const int MAXN = 262144;

//int tree[MAXN * 2];

bool canwin(int v) {
  FOR(i, 0, n) used[i] = 0;
  int loss = 0;
  FOR(i, 0, k + 1) {
    int best = -1;
    FOR(j, 0, n) {
      if (!used[j] && items[j].first - items[j].second - loss >= v && (best < 0 || items[j].second < items[best].second)) {
        best = j;
      }
    }
    if (best < 0) {
      return false;
    }
    used[best] = 1;
    loss += items[best].second;
  }
  return true;
}

void test() {
  scanf("%d%d", &n, &k);
  FOR(i, 0, n) scanf("%d%d", &items[i].first, &items[i].second);
  int left = 0;
  int right = 1000000;
  while (left < right) {
    int mid = (left + right + 1) / 2;
    if (canwin(mid)) {
      left = mid;
    } else {
      right = mid - 1;
    }
  }
  printf("%d\n", left);
}

int main() {
  int T;
  scanf("%d", &T);
  FOR(i, 0, T) test();
  return 0;
}
