#include <iostream>
#include <cmath>

using namespace std;

const int MAXN = 1005;
char go[10][10] = {{1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
               {1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
               {1, 0, 1, 1, 0, 1, 1, 0, 1, 1},
               {0, 0, 0, 1, 0, 0, 1, 0, 0, 1},
               {1, 0, 0, 0, 1, 1, 1, 1, 1, 1},
               {1, 0, 0, 0, 0, 1, 1, 0, 1, 1},
               {0, 0, 0, 0, 0, 0, 1, 0, 0, 1},
               {1, 0, 0, 0, 0, 0, 0, 1, 1, 1},
               {1, 0, 0, 0, 0, 0, 0, 0, 1, 1},
               {0, 0, 0, 0, 0, 0, 0, 0, 0, 1}}, dp[MAXN];

int main() {
    ios_base::sync_with_stdio(false);
    for(int i = 0; i < 10; i++)
        dp[i] = true;
    for(int i = 0; i < MAXN; i++) {
        if(!dp[i])
            continue;
        int p = i % 10;
        for(int j = 0; j < 10; j++)
            if(go[p][j] && i * 10 + j < MAXN)
                dp[i * 10 + j] = true;
    }
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int k;
        cin >> k;
        int ans = 0;
        for(int i = 1; i < MAXN; i++)
            if(dp[i] && abs(i - k) < abs(ans - k))
                ans = i;
        cout << ans << '\n';
    }
    return 0;
}
