#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

string a, b, c;

const ll M = 1000000000 + 9;

const int N = 1e6 + 100;

ll dp[N][2][2];

const int QUEST_CODE = 30;

void make_codes(string &s)
{
	for (int i = 0; i < s.length(); i++)
		if (s[i] != '?')
			s[i] -= 'a';
		else s[i] = QUEST_CODE;
}

int len = 0;

ll f(int pos, bool a_eq, bool b_eq)
{
	if (pos >= len)
	{
		if (a_eq || b_eq) return 0;
		return 1;
	}

	if (dp[pos][a_eq][b_eq] != -1)
		return dp[pos][a_eq][b_eq];

	if (a_eq && a[pos] > b[pos] && a[pos] != QUEST_CODE && b[pos] != QUEST_CODE) return 0;
	if (b_eq && b[pos] > c[pos] && b[pos] != QUEST_CODE && c[pos] != QUEST_CODE) return 0;

	ll res = 0;
	if (a[pos] == QUEST_CODE && b[pos] == QUEST_CODE && c[pos] == QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			res += 26 * f(pos + 1, 1, 1);
			for (int t = 0; t < 26; t++)
			{
				res += t * f(pos + 1, 0, 1);
				res += t * f(pos + 1, 1, 0);
			}
			for (int t = 0; t < 26; t++)
			{
				res += t * (26 - t - 1) * f(pos + 1, 0, 0);
			}
		}
		if (!a_eq && b_eq)
		{
			res += 26 * 26 * f(pos + 1, 0, 1);
			for (int t = 0; t < 26; t++)
			{
				res += 26 * t * f(pos + 1, 0, 0);
			}
		}
		if (a_eq && !b_eq)
		{
			res += 26 * 26 * f(pos + 1, 1, 0);
			for (int t = 0; t < 26; t++)
			{
				res += 26 * t * f(pos + 1, 0, 0);
			}
		}
		if (!a_eq && !b_eq)
		{
			res += 26 * 26 * 26 * f(pos + 1, 0, 0);
		}
	}

	if (a[pos] == QUEST_CODE && b[pos] == QUEST_CODE && c[pos] != QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			res += f(pos + 1, 1, 1);
			res += c[pos] * f(pos + 1, 0, 1);
			res += (c[pos]) * f(pos + 1, 1, 0);
			for (int t = 0; t < c[pos]; t++)
			{
				res += t * f(pos + 1, 0, 0);
			}
		}
		if (!a_eq && b_eq)
		{
			res += 26 * f(pos + 1, 0, 1);
			res += 26 * (c[pos]) * f(pos + 1, 0, 0);
		}
		if (a_eq && !b_eq)
		{
			res += 26 * f(pos + 1, 1, 0);
			for (int t = 0; t < 26; t++)
				res += t * f(pos + 1, 0, 0);
		}
		if (!a_eq && !b_eq)
		{
			res += 26 * 26 * f(pos + 1, 0, 0);
		}
	}

	if (a[pos] == QUEST_CODE && b[pos] != QUEST_CODE && c[pos] == QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			res += f(pos + 1, 1, 1);
			res += b[pos] * f(pos + 1, 0, 1);
			res += (26 - b[pos] - 1) * f(pos + 1, 1, 0);
			res += b[pos] * (26 - b[pos] - 1) * f(pos + 1, 0, 0);
		}
		if (!a_eq && b_eq)
		{
			res += 26 * f(pos + 1, 0, 1);
			res += 26 * (26 - b[pos] - 1) * f(pos + 1, 0, 0);
		}
		if (a_eq && !b_eq)
		{
			res += 26 * f(pos + 1, 1, 0);
			res += b[pos] * 26 * f(pos + 1, 0, 0);
		}
		if (!a_eq && !b_eq)
		{
			res += 26 * 26 * f(pos + 1, 0, 0);
		}
	}

	if (a[pos] != QUEST_CODE && b[pos] == QUEST_CODE && c[pos] == QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			res += f(pos + 1, 1, 1);
			res += (26 - a[pos] - 1) * f(pos + 1, 1, 0);
			res += (26 - a[pos] - 1) * f(pos + 1, 0, 1);
			for (int t = a[pos] + 1; t < 26; t++)
			{
				res += (26 - t - 1) * f(pos + 1, 0, 0);
			}
		}
		if (!a_eq && b_eq)
		{
			res += 26 * f(pos + 1, 0, 1);
			for (int t = 0; t < 26; t++)
			{
				res += (26 - t - 1) * f(pos + 1, 0, 0);
			}
		}
		if (a_eq && !b_eq)
		{
			res += 26 * f(pos + 1, 1, 0);
			res += (26 - a[pos] - 1) * 26 * f(pos + 1, 0, 0);
		}
		if (!a_eq && !b_eq)
		{
			res += 26 * 26 * f(pos + 1, 0, 0);
		}
	}

	if (a[pos] != QUEST_CODE && b[pos] != QUEST_CODE && c[pos] == QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			if (a[pos] == b[pos])
			{
				res += f(pos + 1, 1, 1);
				res += (26 - b[pos] - 1) * f(pos + 1, 1, 0);
			}
			if (a[pos] != b[pos])
			{
				res += f(pos + 1, 0, 1);
				res += (26 - b[pos] - 1) * f(pos + 1, 0, 0);
			}
		}

		if (!a_eq && b_eq)
		{
			res += f(pos + 1, 0, 1);
			res += (26 - b[pos] - 1) * f(pos + 1, 0, 0);
		}

		if (a_eq && !b_eq)
		{
			if (a[pos] == b[pos])
				res += 26 * f(pos + 1, 1, 0);
			else
				res += 26 * f(pos + 1, 0, 0);
		}

		if (!a_eq && !b_eq)
		{
			res += 26 * f(pos + 1, 0, 0);
		}
	}

	if (a[pos] != QUEST_CODE && b[pos] == QUEST_CODE && c[pos] != QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			if (a[pos] == c[pos])
				res += f(pos + 1, 1, 1);
			if (a[pos] < c[pos])
			{
				res += f(pos + 1, 1, 0);
				res += f(pos + 1, 0, 1);
				res += (c[pos] - a[pos] - 1) * f(pos + 1, 0, 0);
			}
		}

		if (!a_eq && b_eq)
		{
			res += f(pos + 1, 0, 1);
			res += c[pos] * f(pos + 1, 0, 0);
		}
		
		if (a_eq && !b_eq)
		{
			res += f(pos + 1, 1, 0);
			res += (26 - a[pos] - 1) * f(pos + 1, 0, 0);
		}

		if (!a_eq && !b_eq)
		{
			res += 26 * f(pos + 1, 0, 0);
		}
	}

	if (a[pos] == QUEST_CODE && b[pos] != QUEST_CODE && c[pos] != QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			if (b[pos] == c[pos])
			{
				res += f(pos + 1, 1, 1);
				res += b[pos] * f(pos + 1, 0, 1);
			}
			else
			{
				res += f(pos + 1, 1, 0);
				res += b[pos] * f(pos + 1, 0, 0);
			}
		}

		if (!a_eq && b_eq)
		{
			if (b[pos] == c[pos])
				res += 26 * f(pos + 1, 0, 1);
			else
				res += 26 * f(pos + 1, 0, 0);
		}

		if (a_eq && !b_eq)
		{
			res += f(pos + 1, 1, 0);
			res += b[pos] * f(pos + 1, 0, 0);
		}

		if (!a_eq && !b_eq)
		{
			res += 26 * f(pos + 1, 0, 0);
		}
	}

	if (a[pos] != QUEST_CODE && b[pos] != QUEST_CODE && c[pos] != QUEST_CODE)
	{
		if (a_eq && b_eq)
		{
			if (a[pos] == b[pos] && b[pos] == c[pos])
				res += f(pos + 1, 1, 1);
			if (a[pos] == b[pos] && b[pos] < c[pos])
				res += f(pos + 1, 1, 0);
			if (a[pos] < b[pos] && b[pos] == c[pos])
				res += f(pos + 1, 0, 1);
			if (a[pos] < b[pos] && b[pos] < c[pos])
				res += f(pos + 1, 0, 0);
		}

		if (!a_eq && b_eq)
		{
			if (b[pos] == c[pos])
				res += f(pos + 1, 0, 1);
			else
				res += f(pos + 1, 0, 0);
		}

		if (a_eq && !b_eq)
		{
			if (a[pos] == b[pos])
				res += f(pos + 1, 1, 0);
			else
				res += f(pos + 1, 0, 0);
		}

		if (!a_eq && !b_eq)
		{
			res += f(pos + 1, 0, 0);
		}
	}

	return (dp[pos][a_eq][b_eq] = res) % M;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	int tests;
	cin >> tests;
	for (int q = 0; q < tests; q++)
	{
		cin >> a >> b >> c;
		len = 0;
		len = max(a.length(), max(b.length(), c.length()));

		while (a.length() < len) a.push_back('a' - 1);
		while (b.length() < len) b.push_back('a' - 1);
		while (c.length() < len) c.push_back('a' - 1);

		make_codes(a);
		make_codes(b);
		make_codes(c);

		for (int i = 0; i < len; i++)
		{
			for (int j = 0; j < 2; j++)
				for (int k = 0; k < 2; k++)
					dp[i][j][k] = -1;
		}

		cout << f(0, 1, 1) << endl;
	}

    return 0;
}