#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

const ll MAX_N = 200000;
ll k;
ll n;

pl items[MAX_N];
pl cur[MAX_N];

bool check (ll ans)
{
	int pos = 0;
	for (int i = 0; i < n; ++i)
	{
		if (items[i].second >= ans)
		{
			cur[pos++] = items[i];
		}
	}
	int len = pos;

	if (len == 0)
	{
		return false;
	}

	for (int m = 0; m < k; ++m)
	{
		pos = 0;
		ll min_cost = cur[0].first;
		for (int i = 1; i < len; ++i)
		{
			cur[i].second -= min_cost;
			if (cur[i].second >= ans)
			{
				cur[pos++] = cur[i];
			}
		}

		len = pos;
		if (len == 0)
		{
			return false;
		}

	}

	return len != 0;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	int tests;
	cin >> tests;
	for (int q = 0; q < tests; q++)
	{
		cin >> n >> k;
		for (int i = 0; i < n; ++i)
		{
			ll v, c;
			cin >> v >> c;
			items[i].second = v - c;
			items[i].first = c;
		}

		sort(items, items + n);
		ll l = 0;
		ll r = 20000000;

		while (r - l > 1)
		{
			ll mid = (l + r) / 2;

			if (check(mid))
			{
				l = mid;
			}
			else
			{
				r = mid;
			}
		}

		cout << l << endl; 
	}

    return 0;
}