#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000007;
#define mp make_pair

int col(int a){
	if(a){
		return (a-1)%3;
	}
	else return 1;
}

int row(int a){
	if(a){
		return (a-1)/3;
	}
	else{
		return 4;
	}
}

bool good(int a, int b){
	return (col(b)>=col(a) && row(b)>=row(a));
}

int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int t;
	cin>>t;
	vector<int>possible(201);
	for(int i=1; i<=200; ++i){
		vector<int>dig;
		int I=i;
		while(I){
			dig.push_back(I%10);
			I/=10;
		}
		bool ok=true;
		for(int j=1; j<dig.size(); ++j){
			if(!good(dig[j], dig[j-1])){
				ok=false;
				break;
			}
		}
		if(ok)possible[i]=1;
	}
	for(int T=0;T<t;++T){
		int n;
		cin>>n;
		int best = 1;
		for(int i=1; i<=200; ++i){
			if(possible[i] && abs(i-n) < abs(best-n)){
				best = i;
			}
		}
		cout << best << endl;
	}

	return 0;
}