#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

int n;

bool read() {
	if (scanf("%d", &n) != 1)
		return false;
	return true;
}

void solve() {
	int b = n << 1;

	int a = 1;

	while (!(b & 1)) {
		a <<= 1;
		b >>= 1;
	}

	if (a < b)
		swap(a, b);

	if (b == 1)
		puts("IMPOSSIBLE");
	else {
		int f = (a - (b - 1)) >> 1;
		printf("%d = ", n);
		forn(i, b) {
			if (i)
				printf(" + ");
			printf("%d", f + i);
		}
		puts("");
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	while (read())
		solve();

	return 0;
}