#include <iostream>
#include <sstream>
#include <deque>

using namespace std;

deque<int> D;

void merge() {
	while(D.size() >= 2 && D[0] == D[1]) {
		D.pop_front();
		D[0] += D[0];
	}
	while(D.size() >= 2 && D.back() == D[D.size() - 2]) {
		D.pop_back();
		D.back() += D.back();
	}
}

int main() {
	cin.sync_with_stdio(false);
	int Te;
	cin >> Te;
	for(int te = 0; te < Te; ++te) {
		int n;
		cin >> n;
		string S;
		S.resize(n);
		D.clear();
		for(int i = 0; i < n; ++i) {
			int x;
			cin >> x;
			if(i < 2) {
				S[i] = 'r';
				D.push_back(x);
			} else {
				int a = D.front();
				int b = D.back();
				
				if(a == b) {
					S[i] = 'r';
					D.push_back(x);
				} else if(a < b) {
					if(x <= a) {
						S[i] = 'l';
						D.push_front(x);
					} else {
						S[i] = 'r';
						D.push_back(x);
					}
				} else {
					if(x <= b) {
						S[i] = 'r';
						D.push_back(x);
					} else {
						S[i] = 'l';
						D.push_front(x);
					}
				}
			}
			merge();
		}
		
		if(D.size() == 1) {
			cout << S << "\n";
		} else {
			cout << "no\n";
		}
	}
	
	return 0;
}
