#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

typedef long long int Z;

Z sz;
string A, B, C;

const char BA = 'a' - 1;
const char AZ = 'z' + 1;

const Z M = 1000000009;

const Z LE = 0;
const Z EQ = 1;
const Z GE = 2;
Z ways[3][3][28][28][28];

const Z LEb = 1 << LE;
const Z EQb = 1 << EQ;
const Z GEb = 1 << GE;

Z getWays(Z bxy, Z byz, char x, char y, char z) {
	Z ret = 0;
	for(Z ixy = 0; ixy < 3; ++ixy) {
	for(Z iyz = 0; iyz < 3; ++iyz) {
		if(((1 << ixy) & bxy) && ((1 << iyz) & byz)) {
			ret += ways[ixy][iyz][x - BA][y - BA][z - BA];
			ret %= M;
		}
	}
	}
	return ret;
}

Z bits(Z a, Z b) {
	if(a == 0 && b == 0) return EQb;
	if(a == 0 && b == 1) return LEb;
	return LEb | EQb | GEb;
}

int main() {
	for(int dxy = 0; dxy < 3; ++dxy) {
	for(int dyz = 0; dyz < 3; ++dyz) {
	for(char x = BA; x <= AZ; ++x) {
	for(char y = BA; y <= AZ; ++y) {
	for(char z = BA; z <= AZ; ++z) {
		Z& val = ways[dxy][dyz][x - BA][y - BA][z - BA];
		for(char xv = BA; xv <= 'z'; ++xv) {
			if(x != AZ && xv != x) continue;
			if(x == AZ && xv == BA) continue;
			for(char yv = BA; yv <= 'z'; ++yv) {
				if(y != AZ && yv != y) continue;
				if(y == AZ && yv == BA) continue;
				if(dxy == LE && !(xv < yv)) continue;
				if(dxy == EQ && !(xv == yv)) continue;
				if(dxy == GE && !(xv > yv)) continue;
				for(char zv = BA; zv <= 'z'; ++zv) {
					if(z != AZ && zv != z) continue;
					if(z == AZ && zv == BA) continue;
					if(dyz == LE && !(yv < zv)) continue;
					if(dyz == EQ && !(yv == zv)) continue;
					if(dyz == GE && !(yv > zv)) continue;
					
					++val;
					val %= M;
				}
			}
		}
	}
	}
	}
	}
	}
	
	cin.sync_with_stdio(false);
	
	Z Te;
	cin >> Te;
	
	for(Z te = 0; te < Te; ++te) {
		cin >> A >> B >> C;
		sz = max(A.size(), max(B.size(), C.size()));
		A.resize(sz, BA);
		B.resize(sz, BA);
		C.resize(sz, BA);
		for(Z i = 0; i < sz; ++i) {
			if(A[i] == '?') A[i] = AZ;
			if(B[i] == '?') B[i] = AZ;
			if(C[i] == '?') C[i] = AZ;
		}
		//cout << A << "\n" << B << "\n" << C << "\n\n";
		
		Z T[2][2];
		T[0][0] = 1;
		T[0][1] = 0;
		T[1][0] = 0;
		T[1][1] = 0;
		for(Z i = 0; i < sz; ++i) {
			Z newT[2][2];
			fill((Z*)newT, (Z*)newT + 4, 0);
			
			for(Z ixy = 0; ixy < 2; ++ixy) {
			for(Z iyz = 0; iyz < 2; ++iyz) {
			for(Z fixy = 0; fixy <= ixy; ++fixy) {
			for(Z fiyz = 0; fiyz <= iyz; ++fiyz) {
				newT[ixy][iyz] += getWays(bits(fixy, ixy), bits(fiyz, iyz), A[i], B[i], C[i]) * T[fixy][fiyz];
				newT[ixy][iyz] %= M;
			}
			}
			}
			}
			
			copy((Z*)newT, (Z*)newT + 4, (Z*)T);
		}
		
		cout << T[1][1] << "\n";
	}
	
	return 0;
}
