import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by olymp on 11/20/14.
 */
public class D {
    static Scanner in;
    static int n;
    static int[] x;
    static int[] y;
    static int[] r;

    static int[] dir;
    static BigInteger[] nom, denom;

    public static void dfs(int v) {
        for (int i = 0; i < n; i++) {
            long dist = 1L * (x[v] - x[i]) * (x[v] - x[i]) + 1L * (y[v] - y[i]) * (y[v] - y[i]);
            if (dist != 1L * (r[v] + r[i]) * (r[v] + r[i])) {
                continue;
            }
            if (dir[i] != -1) {
                continue;
            }
            dir[i] = dir[v] ^ 1;
            nom[i] = nom[v].multiply(BigInteger.valueOf(r[v]));
            denom[i] = denom[v].multiply(BigInteger.valueOf(r[i]));
            BigInteger g = nom[i].gcd(denom[i]);
            nom[i] = nom[i].divide(g);
            denom[i] = denom[i].divide(g);
            dfs(i);
        }
    }

    public static void main(String args[]) {
        in = new Scanner(System.in);
        int T = in.nextInt();
        for (int test = 1; test <= T; test++) {
            n = in.nextInt();
            x = new int[n];
            y = new int[n];
            r = new int[n];
            dir  = new int[n];
            for (int i = 0; i < n; i++) {
                dir[i] = -1;
            }
            nom = new BigInteger[n];
            denom = new BigInteger[n];

            for (int i = 0; i < n; i++) {
                x[i] = in.nextInt();
                y[i] = in.nextInt();
                r[i] = in.nextInt();
            }

            dir[0] = 0;
            nom[0] = BigInteger.ONE;
            denom[0] = BigInteger.ONE;

            dfs(0);

            for (int i = 0; i < n; i++) {
                if (dir[i] == -1) {
                    System.out.println("not moving");
                } else {
                    System.out.print(nom[i].toString());
                    if (!denom[i].equals(BigInteger.ONE)) {
                        System.out.print("/" + denom[i].toString());
                    }
                    if (dir[i] == 0) {
                        System.out.println(" clockwise");
                    } else {
                        System.out.println(" counterclockwise");
                    }
                }
            }
        }
    }
}
