#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

const int d[4][3] = {
    {1, 2, 3},
    {4, 5, 6},
    {7, 8, 9},
    {-1, 0, -1}
};
const int dx[3] = {0, 0, 1};
const int dy[3] = {0, 1, 0};

bool dd[1000];
int k;

void readin(){
    scanf("%d", &k);
}

void build(){
    for (int i = 0; i <= 999; i++){
        int j = i;
        int u = 4, v = 4;
        bool good = true;
        while (j){
            int z = j % 10;
            for (int x = 0; x < 4; x++){
                for (int y = 0; y < 3; y++)
                    if (d[x][y] == z){
                        if (x <= u && y <= v){
                            u = x;
                            v = y;
                            break;
                        } else{
                            good = false;
                            break;
                        }
                    }
            }
            j /= 10;
        }

        if (good) dd[i] = true;
    }
}

void init(){
    memset(dd, false, sizeof(dd));
    build();
}

void process(){
    int res = 0;
    while (true){
        if (k - res >= 0 & dd[k - res]){
            res = k - res;
            break;
        }
        if (k + res < 1000 & dd[k + res]){
            res = k + res;
            break;
        }
        res++;
    }
    printf("%d\n", res);
}

void solve()
{
    init();
    int test;
    scanf("%d", &test);
    while (test--){
        readin();
        process();
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif