#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

void solve()
{
    int t;
    scanf("%d", &t);
    for (int q = 0; q < t; q++)
    {
        int n;
        scanf("%d", &n);
        vector <pair<int, int> > sp(n);
        LL W = 0, B = 0;
        for (int i = 0; i < n; i++)
        {
            int c;
            char ch;
            scanf("%d %c\n", &c, &ch);
            sp[i] = mp(c, ch == 'W' ? 0 : 1);
            if (ch == 'W')
                W += c;
            else
                B += c;
        }
        if (B == 0)
        {
            cout << W << endl;
            continue;
        }
        if (W == 0)
        {
            cout << B << endl;
            continue;
        }

        LL cnt = 0;
        LL w = 0, b = 0;
        for (int i = 0; i < n; i++)
        {
            if (sp[i].Y == 0)
            {
                LL f = b * W - w * B;
                if (f % B == 0)
                {
                    LL a = f / B;
                    if (a > 0 && a <= sp[i].X)
                    {
                        sp[i].X -= a;
                        i--;
                        cnt++;
                        b = w = 0;
                    }
                    else
                         w += sp[i].X;
                }
                else
                    w += sp[i].X;
            }
            else
            {
                LL f = w * B - b * W;
                if (f % W == 0)
                {
                    LL a = f / W;
                    if (a > 0 && a <= sp[i].X)
                    {
                        sp[i].X -= a;
                        i--;
                        cnt++;
                        b = w = 0;
                    }
                     else
                         b += sp[i].X;
                }
                else
                   b += sp[i].X;
            }
        }

        cout << cnt << endl;
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
   // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif