// author: Grzegorz Herman

import java.io.*;
import java.util.*;

public class F
{
    static final int  A = 26;
    static final char B = 'a' - 1;
    static final long M = 1000000009;

	public static void main(String[] args) throws IOException 
	{
        int[][] options = new int[A+2][];
        options[A+1] = new int[A];
        for (int i=0; i<=A; i++)
            options[i] = new int[] { i };
        for (int i=1; i<=A; i++)
            options[A+1][i-1] = i;
        int[][][][][][][][] transitions = new int[3][3][3][][][][][];
        for (int s0=0; s0<3; s0++)
            for (int s1=0; s1<3; s1++)
                for (int s2=0; s2<3; s2++)
                {
                    transitions[s0][s1][s2] = new int[A+2][A+2][A+2][][];
                    for (int m0=0; m0<A+2; m0++)
                        for (int m1=0; m1<A+2; m1++)
                            for (int m2=0; m2<A+2; m2++)
                            {
                                int[][][] factors = new int[3][3][3];
                                for (int c0 : options[m0])
                                    for (int c1 : options[m1])
                                        for (int c2 : options[m2])
                                        {
                                            int r0 = (3*c0+s0 > 3*c1+s1 ? 1 : 0) + (3*c0+s0 > 3*c2+s2 ? 1 : 0);
                                            int r1 = (3*c1+s1 > 3*c0+s0 ? 1 : 0) + (3*c1+s1 > 3*c2+s2 ? 1 : 0);
                                            int r2 = (3*c2+s2 > 3*c0+s0 ? 1 : 0) + (3*c2+s2 > 3*c1+s1 ? 1 : 0);
                                            factors[r0][r1][r2]++;
                                        }
                                ArrayList<int[]> ts = new ArrayList<int[]>();
                                int[] t = new int[4];
                                for (t[0]=0; t[0]<3; t[0]++)
                                    for (t[1]=0; t[1]<3; t[1]++)
                                        for (t[2]=0; t[2]<3; t[2]++)
                                            if ((t[3] = factors[t[0]][t[1]][t[2]]) > 0)
                                                ts.add(t.clone());
                                transitions[s0][s1][s2][m0][m1][m2] = ts.toArray(new int[0][]);
                            }
                }
		BufferedReader rd = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter wr = new PrintWriter(System.out);
        int T = Integer.parseInt(rd.readLine());
        for (int tt=0; tt<T; tt++)
        {
            String[] words = new String[3];
            for (int i=0; i<3; i++)
                words[i] = rd.readLine().replace('?', (char)('z'+1));
            int maxlen = 0;
            for (int i=0; i<3; i++)
                maxlen = Math.max(maxlen, words[i].length());
            for (int i=0; i<3; i++)
                words[i] = words[i] + new String(new char[maxlen-words[i].length()]).replace('\0', B);
            long[][][] counts = new long[3][3][3];
            counts[0][0][0] = 1;
            for (int j=maxlen-1; j>=0; j--)
            {
                int c0 = words[0].charAt(j) - B;
                int c1 = words[1].charAt(j) - B;
                int c2 = words[2].charAt(j) - B;
                long[][][] newcounts = new long[3][3][3];
                for (int s0=0; s0<3; s0++)
                    for (int s1=0; s1<3; s1++)
                        for (int s2=0; s2<3; s2++)
                            for (int[] t : transitions[s0][s1][s2][c0][c1][c2])
                                newcounts[t[0]][t[1]][t[2]] += (counts[s0][s1][s2] * t[3]) % M;
                counts = newcounts;
            }
            wr.println(counts[0][1][2] % M);
        }
        wr.close();
	}
}
