#include <stdlib.h>
// Author: Damian Straszak

#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <queue>
#include <map>
#include <cstdio>
#include <iomanip>
#include <sstream>
#include <iostream>
#include <cstring>
#include <complex>
#define REP(i,x,v)for(int i=x;i<=v;i++)
#define REPD(i,x,v)for(int i=x;i>=v;i--)
#define FOR(i,v)for(int i=0;i<v;i++)
#define FORE(i,t) for (typeof(t.begin()) i=t.begin(); i!=t.end(); i++)
#define REMIN(x,y) (x)=min((x),(y))
#define REMAX(x,y) (x)=max((x),(y))
#define pb push_back
#define sz size()
#define mp make_pair
#define fi first
#define se second
#define ll long long
#define IN(x,y) ((y).find((x))!=(y).end())
#define un(v) v.erase(unique(ALL(v)),v.end())
#define LOLDBG
#ifdef LOLDBG
#define DBG(vari) cerr<<#vari<<" = "<<vari<<endl;
#define DBG2(v1,v2) cerr<<(v1)<<" - "<<(v2)<<endl;
#else
#define DBG(vari)
#define DBG2(v1,v2)
#endif
#define CZ(x) scanf("%d",&(x));
#define CZ2(x,y) scanf("%d%d",&(x),&(y));
#define CZ3(x,y,z) scanf("%d%d%d",&(x),&(y),&(z));
#define ALL(x) (x).begin(),(x).end()
#define tests int dsdsf;cin>>dsdsf;while(dsdsf--)
#define testss int dsdsf;CZ(dsdsf);while(dsdsf--)
using namespace std;
typedef pair<int,int> pii;
typedef vector<int> vi;
template<typename T,typename TT> ostream &operator<<(ostream &s,pair<T,TT> t) {return s<<"("<<t.first<<","<<t.second<<")";}
template<typename T> ostream &operator<<(ostream &s,vector<T> t){s<<"{";FOR(i,t.size())s<<t[i]<<(i==t.size()-1?"":",");return s<<"}"<<endl; }

vi testy;
#define M 1000000000

ll ran()
{
	ll x=0;
	FOR(i,5) x=x*(1<<10)+rand()%(1<<10);
	return x;
}

bool is_prime(ll x)
{
    if (x<2) return 0;
    for(int j=2;(ll)j*j<=x;j++) if (x%j==0) return 0;
    return 1;
}

void gen_small()
{
	REP(i,1,333) testy.pb(i);
}

void gen_big()
{
	REP(i,1,33) testy.pb(M-i+1);
}

void gen_pow2()
{
	for(int i=0;(1<<i)<=M;i++) testy.pb((1<<i));
}

void gen_rand()
{
	FOR(i,8000)
	{
		testy.pb(1+ran()%M);
	}
}

void gen_rand_primes()
{
	FOR(i,200)
	{
		int p;
		while(1)
		{
			p=2+ran()%(M-5);
			if (!is_prime(p)) continue;
			if (p>M/2) break;
		}
		testy.pb(p);
	}
}

void gen_rand_2primes()
{
	FOR(i,200)
	{
		int p;
		while(1)
		{
			p=2+ran()%(M/2-5);
			if (!is_prime(p)) continue;
			if (p>M/3) break;
		}
		testy.pb(2*p);
	}
}

void gen_rand_primeprime()
{
	FOR(i,100)
	{
		int p,q;
		while(1)
		{
			p=2+ran()%((int)sqrt(M)-5);
			if (!is_prime(p)) continue;
			else break;
		}
		while(1)
		{
			q=2+ran()%((int)sqrt(M)-5);
			if (!is_prime(q)) continue;
			else break;
		}
		testy.pb(p*q);
	}
}

void gen_rand_2powprimes()
{
	FOR(i,200)
	{
		int p;
		while(1)
		{
			p=2+ran()%(M/(1+rand()%10)-5);
			if (!is_prime(p)) continue;
			break;
		}
		while(2*p<=M) p*=2;
		testy.pb(p);
	}
}

void gen_rand_squares()
{
	FOR(i,200)
	{
		int s=ran()%(1+(int)sqrt(M)-3);
		testy.pb(s*s);
	}
}

void gen_small_div()
{
	FOR(i,100)
	{
		ll s=1;
		FOR(j,59)
		{
			int r=ran()%6+1;
			if (s*r<=M) s*=r;
		}
		testy.pb(s);
	}
}


int main()
{
    ios_base::sync_with_stdio(0);
    srand(112324);
    gen_small();
    gen_big();
    FOR(i,50) gen_pow2();
    gen_rand();
    gen_rand_primes();
    gen_rand_2primes();
    gen_rand_squares();
    gen_rand_2powprimes();
    gen_rand_primeprime();
    gen_small_div();
    cout<<testy.sz<<"\n";
    FOR(i,testy.sz) cout<<testy[i]<<"\n";

	return 0;
}


