#include <stdlib.h>
#include <string.h>
#include <cstdio>
#include <algorithm>

using namespace std;

typedef pair<int,int> PI;

const int maxn = 100000;
const int maxk = 9;

const int infty = 2e9;

PI A[maxn];
bool used[maxn];

int n;

int go(int magic)
{
  if (magic==-1)
    return infty;
  int result = 0;
  for(int i=0; i<n; i++)
    if (!used[i])
    {
      used[i] = true;
      int sub = go(magic-1);
      used[i] = false;
      result = max(result,min(A[i].first,sub)-A[i].second);
    }
  return result;
}

int main()
{
  int TT;
  scanf("%d",&TT);
  while(TT--)
  {
    int k;
    scanf("%d %d",&n,&k);
    for(int i=0; i<n; i++)
      scanf("%d %d",&A[i].first,&A[i].second);
    for(int i=0; i<n; i++)
      used[i] = false;
    printf("%d\n",go(k));
  }
}
