#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e6+11;
const int inf = int(1e9);
const int mod = inf + 9;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, ssz, psz, tsz;
char s[maxn], p[maxn], t[maxn];
int dp[4][maxn];

int calc(int i, int k) {
	if(i == n) return k == 0;
	int &res = dp[k][i];
	if(res != -1) return res;
	res = 0;
	if(k == 0) {

		int cnt = (s[i]=='?') + (t[i]=='?') + (p[i]=='?');
		int p = 1;
		while(cnt--) p *= 26;
		res = p * 1ll * calc(i+1, 0) % mod;

	} else if(k == 1) {

		int temp = (p[i]=='?' ? 26 : 1);
		char x = s[i], y = t[i];
		if(x == '?' && y == '?') {
			res += 26ll * calc(i+1, 1) % mod; res %= mod;
			res += 13ll * 25ll * calc(i+1, 0) % mod; res %= mod;
		} else if(x == '?') {
			if(y >= 'a') res += calc(i+1, 1); res %= mod;
			res += max(y-'a', 0) * 1ll * calc(i+1, 0) % mod; res %= mod;
		} else if(y == '?') {
			if(x >= 'a') res += calc(i+1, 1); res %= mod;
			res += ('z'-x) * 1ll * calc(i+1, 0) % mod; res %= mod;
		} else {
			if(x == y) res = (res + calc(i+1, 1)) % mod;
			if(x > y) res = 0;
			if(x < y) res = (res + calc(i+1, 0)) % mod;
		}
		res = 1ll * res * temp % mod;

	} else if(k == 2) {

		int temp = (s[i]=='?' ? 26 : 1);
		char x = t[i], y = p[i];
		if(x == '?' && y == '?') {
			res += 26ll * calc(i+1, 2) % mod; res %= mod;
			res += 13ll * 25ll * calc(i+1, 0) % mod; res %= mod;
		} else if(x == '?') {
			if(y >= 'a') res += calc(i+1, 2); res %= mod;
			res += max(y-'a', 0) * 1ll * calc(i+1, 0) % mod; res %= mod;
		} else if(y == '?') {
			if(x >= 'a') res += calc(i+1, 2); res %= mod;
			res += ('z'-x) * 1ll * calc(i+1, 0) % mod; res %= mod;
		} else {
			if(x == y) res = (res + calc(i+1, 2)) % mod;
			if(x > y) res = 0;
			if(x < y) res = (res + calc(i+1, 0)) % mod;
		}
		res = 1ll * res * temp % mod;
	
	} else if(k == 3) {

		char x = s[i], y = t[i], z = p[i];

		if(x == '?' && y == '?' && z == '?') {
			res += 26ll * calc(i+1, 3) % mod; res %= mod;
			res += 25ll * 13 * ((calc(i+1, 1) + calc(i+1, 2)) % mod) % mod; res %= mod;
			res += 4ll * 25ll * 26ll * calc(i+1, 0) % mod; res %= mod;
		}
		
		if(x == '?' && y == '?' && z != '?') {
			int k = max(z-'a', 0);
			res += k * 1ll * (k-1) / 2 * calc(i+1, 0) % mod; res %= mod;
			res += k * 1ll * calc(i+1, 1) % mod; res %= mod;
			if(z >= 'a') res += k * 1ll * calc(i+1, 2) % mod; res %= mod;
			res += (z >= 'a') * calc(i+1, 3) % mod; res %= mod;
		}
		
		if(x == '?' && y != '?' && z == '?') {
			int k1 = max(y-'a', 0);
			int k2 = 'z'-y;
			res += 1ll * k1 * k2 * calc(i+1, 0) % mod; res %= mod;
			res += 1ll * (y >= 'a') * k2 * calc(i+1, 1) % mod; res %= mod;
			res += 1ll * k1 * calc(i+1, 2) % mod; res %= mod;
			res += 1ll * (y >= 'a') * calc(i+1, 3) % mod; res %= mod;
		}
		
		if(x != '?' && y == '?' && z == '?') {
			int k = 'z' - x;
			res += k * 1ll * (k-1) / 2 * calc(i+1, 0) % mod; res %= mod;
			if(x >= 'a') {
				res += calc(i+1, 3) % mod; res %= mod;
				res += k * 1ll * calc(i+1, 1) % mod; res %= mod;
			}
			res += k * 1ll * calc(i+1, 2) % mod; res %= mod;
		}

		if(x == '?' && y != '?' && z != '?') {
			if(y > z) return res = 0;
			int k = max(y-'a', 0);
			res += (y>='a')*calc(i+1, (y != z ? 1 : 3)) % mod; res %= mod;
			res += k * 1ll * calc(i+1, (y < z ? 0 : 2)) % mod; res %= mod;
		}
		
		if(x != '?' && y == '?' && z != '?') {
			if(x > z) return res = 0;
			if(x == z) {
				if(x >= 'a') return res = calc(i+1, 3);
				else return res = 0;
			}
			int k = z-x-1;
			if(x >= 'a') res += calc(i + 1, 1) % mod; res %= mod;
			res += calc(i+1, 2) % mod; res %= mod;
			res += 1ll * k * calc(i+1, 0) % mod;
		}

		if(x != '?' && y != '?' && z == '?') {
			if(x > y) return res = 0;
			int k = 'z'-y;
			if(x == y){
				res += (y >= 'a') * calc(i+1, 3) % mod; res %= mod;
				res += 1ll * k * calc(i+1, 1) % mod; res %= mod;
			}
			if(x < y) {
				res += calc(i+1, 2); res %= mod;
				res += 1ll * k * calc(i + 1, 0) % mod; res %= mod;
			}
		}
		if(x != '?' && y != '?' && z != '?') {
			if(x > y || x > z || y > z) return res = 0;
			if(x == y && y == z) return res = calc(i+1, 3);
			if(x == y) return res = calc(i+1, 1);
			if(y == z) return res = calc(i+1, 2);
			return res = calc(i+1, 0);
		}

	}
	return res;
}

void solve() {
	gets(s); ssz = strlen(s);
	gets(t); tsz = strlen(t);
	gets(p); psz = strlen(p);
	n = max(ssz, max(tsz, psz));
	for(int i = ssz; i < n; i++) s[i] = 'a'-1;
	for(int i = tsz; i < n; i++) t[i] = 'a'-1;
	for(int i = psz; i < n; i++) p[i] = 'a'-1;

	for(int i = 0; i <= n; i++)
		for(int j = 0; j < 4; j++) dp[j][i] = -1;

	printf("%d\n", calc(0, 3));
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;

	scanf("%d\n", &t);

	while(t--) solve();

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
