#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <utility>
#include <queue>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define fname ""
#define c first.first
#define v first.second
#define pos second

typedef long long LL;
typedef pair<int,int> pii;

const int maxn = (int)1e6;
const LL inf = (LL)1e18;
const int mod = (int)1e9 + 7;
const double eps = 1e-9;

int test, n, k, used[maxn];
long long ans, sum, min_;
pair <pii, int> a[maxn];
priority_queue <pair <pii, int> > q;

void init() {
	sum = ans = 0;
	min_ = inf;
	return;
}

int main() {
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> test;
	while (test--) {
		cin >> n >> k;
		for (int i = 1; i <= n; ++i) {
			cin >> a[i].v >> a[i].c;
			a[i].pos = i;
			q.push(a[i]);

			if ((int)q.size() > k)
				q.pop();

			used[i] = false;
		}

		while (!q.empty()) {
			sum += q.top().c;
			used[q.top().pos] = true;
			q.pop();
		}

		for (int i = 1; i <= n; ++i)
			if (!used[i])
				min_ = min(min_, a[i].c + 0ll);

		for (int i = 1; i <= n; ++i)
			if (!used[i]) {
				ans = max(ans, a[i].v - a[i].c - sum);
			} else {
				for (int j = 1; j <= n; ++j)
					if (!used[j])
						ans = max(ans, a[i].v - sum - min_);
			}

		cout << ans << '\n';
		init();
	}

	return 0;
}
