#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

const int n = 4, m = 3;
const int none = -1;

int values[n][m] = {{1, 2, 3}, {4, 5, 6}, {7, 8, 9}, {none, 0, none}};
vector < ll > resultValues;
const ll buben = 10000;

void rec(int x, int y, ll value) {
	//cout << x << " " << y << " " << value << endl;
	resultValues.pb(value);
	if(x >= n || y >= m || values[x][y] == none || value > buben) return;
	if(value != 0 || values[x][y] != 0)
		rec(x, y, 10 * value + values[x][y]);
	rec(x + 1, y, value);
	rec(x, y + 1, value);
	rec(x + 1, y, 10 * value + values[x][y]);
	rec(x, y + 1, 10 * value + values[x][y]);
}

int main() {
	ios_base::sync_with_stdio(0);
	rec(0, 0, 0);
	sort(resultValues.begin(), resultValues.end());
	resultValues.erase(unique(resultValues.begin(), resultValues.end()), resultValues.end());
	int tests;
	cin >> tests;
	for(int t = 0; t < tests; t++) {
		ll n;
		cin >> n;
		ll result = *lower_bound(resultValues.begin(), resultValues.end(), n);
		for(ll i : resultValues) {
			//cout << i << endl;
			if(abs(n - i) < abs(result - n)) result = i;
		}
		cout << result << "\n";
	}
	return 0;
}