#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
void precalc();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;
	precalc();

	int t = 1;
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int mod = 1000000009;

string s[3];

vector<vector<int>> matrix[60][60];

void precalc() {
	for (char c = 'a'; c <= 'z'; ++c) {
		for (char fs = 'a'; ; ++fs) {
			if (fs == 'z' + 1)
				fs = '?';
			for (char sc = 'a'; ; ++sc) {
				if (sc == 'z' + 1)
					sc = '?';

				if (c == 'a')
					matrix[fs - '?'][sc - '?'].assign(4, vector<int>(4,0));

				//assert(matrix[fs - '?'][sc - '?'].size() == 4);

				int goodLess[2] = {0, 0}, goodEq[2] = {0, 0}, goodAll[2] = {0, 0};

				if (fs != '?') {
					goodAll[0] = 1;
					if (fs < c)
						goodLess[0] = 1;
					if (fs == c)
						goodEq[0] = 1;
				}
				else {
					goodAll[0] = 26;
					goodLess[0] = max(0, (signed)c - 'a');
					goodEq[0] = 1;
				}

				if (sc != '?') {
					goodAll[1] = 1;
					if (sc > c)
						goodLess[1] = 1;
					if (sc == c)
						goodEq[1] = 1;
				}
				else {
					goodAll[1] = 26;
					goodLess[1] = min('z' - c, 26);
					goodEq[1] = 1;
				}

				vector<vector<int>>& res = matrix[fs - '?'][sc - '?'];

				res[0][0] += goodAll[0] * goodAll[1];
				res[0][1] += goodAll[0] * goodLess[1];
				res[0][2] += goodAll[1] * goodLess[0];
				res[0][3] += goodLess[0] * goodLess[1];

				res[1][1] += goodEq[1] * goodAll[0];
				res[1][3] += goodEq[1] * goodLess[0];

				res[2][2] += goodEq[0] * goodAll[1];
				res[2][3] += goodEq[0] * goodLess[1];

				res[3][3] += goodEq[0] * goodEq[1];

				if (sc == '?' + 1)
					break;
			}
			if (fs == '?' + 1)
				break;
		}
	}
}

void solve() {
	int mxLen = 0;
	for (int i = 0; i < 3; ++i) {
		cin >> s[i];
		mxLen = max(mxLen, (int)s[i].length());
	}

	for (int i = 0; i < 3; ++i) {
		while(s[i].length() < mxLen)
			s[i] += ('?' + 1);
	}

	vector<vector<vector<li>>> dp(mxLen + 1, vector<vector<li>>(2, vector<li>(2, 0)));
	dp[0][1][1] = 1;

	for (int len = 0; len < mxLen; ++len) {

		if (s[1][len] != '?') {
			char c = s[1][len];
			
			int goodLess[2] = {0, 0}, goodEq[2] = {0, 0}, goodAll[2] = {0, 0};

			if (s[0][len] != '?') {
				goodAll[0] = 1;
				if (s[0][len] < c)
					goodLess[0] = 1;
				if (s[0][len] == c)
					goodEq[0] = 1;
			}
			else {
				goodAll[0] = 26;
				goodLess[0] = max(0, (signed)c - 'a');
				goodEq[0] = 1;
			}

			if (s[2][len] != '?') {
				goodAll[1] = 1;
				if (s[2][len] > c)
					goodLess[1] = 1;
				if (s[2][len] == c)
					goodEq[1] = 1;
			}
			else {
				goodAll[1] = 26;
				goodLess[1] = min('z' - c, 26);
				goodEq[1] = 1;
			}


			dp[len + 1][0][0] += dp[len][0][0] * goodAll[0] * goodAll[1] + dp[len][0][1] * goodAll[0] * goodLess[1] + dp[len][1][0] * goodAll[1] * goodLess[0] + 
				dp[len][1][1] * goodLess[0] * goodLess[1];
			
			dp[len + 1][1][1] += dp[len][1][1] * goodEq[0] * goodEq[1];

			dp[len + 1][1][0] += dp[len][1][0] * goodEq[0] * goodAll[1] + dp[len][1][1] * goodEq[0] * goodLess[1];

			dp[len + 1][0][1] += dp[len][0][1] * goodEq[1] * goodAll[0] + dp[len][1][1] * goodEq[1] * goodLess[0];

		}

		else {

			vector<vector<int>>& res = matrix[s[0][len] - '?'][s[2][len] - '?'];

			//cout << s[0][len] << s[1][len] << endl;

			//cout << res.size() << endl;

			dp[len + 1][0][0] += dp[len][0][0] * res[0][0] + dp[len][0][1] * res[0][1] + dp[len][1][0] * res[0][2] + dp[len][1][1] * res[0][3];

			dp[len + 1][0][1] += dp[len][0][0] * res[1][0] + dp[len][0][1] * res[1][1] + dp[len][1][0] * res[1][2] + dp[len][1][1] * res[1][3];

			dp[len + 1][1][0] += dp[len][0][0] * res[2][0] + dp[len][0][1] * res[2][1] + dp[len][1][0] * res[2][2] + dp[len][1][1] * res[2][3];

			dp[len + 1][1][1] += dp[len][0][0] * res[3][0] + dp[len][0][1] * res[3][1] + dp[len][1][0] * res[3][2] + dp[len][1][1] * res[3][3];

		}

		for (int i = 0; i < 2; ++i)
			for (int j = 0; j < 2; ++j)
				dp[len + 1][i][j] %= mod;

	}

	cout << dp[mxLen][0][0] << "\n";

	//cerr << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << endl;
}