#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

int x[10] = { 4, 1, 1, 1, 2, 2, 2, 3, 3, 3 };
int y[10] = { 2, 1, 2, 3, 1, 2, 3, 1, 2, 3 };
bool used[210];

bool check(int n) {
	bool flag = true;
	int a, b, c;
	if (n < 10) {
		return true;
	} else if (n < 100) {
		a = n / 10;
		b = n % 10;
		return (x[a] <= x[b] && y[a] <= y[b]);
	} else {
		a = n / 100;
		n %= 100;
		b = n / 10;
		n %= 10;
		c = n;
		//cerr << a << ' ' << b << ' ' << c << endl;
		return (x[a] <= x[b] && y[a] <= y[b] && x[b] <= x[c] && y[b] <= y[c]);
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	for (int i = 0; i <= 201; i++) 
		used[i] = check(i);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int n;
		cin >> n;
		int curl = n, curr = n;
		while (!used[curl])
			curl--;
		while (!used[curr])
			curr++;
		if (n - curl < curr - n)
			cout << curl << '\n';
		else
			cout << curr << '\n';
	}
}