#include <bits/stdc++.h>

using namespace std;

#define int int64_t
int gcd(int a, int b)
{
    if(b==0)
        return a;
    else
        return(gcd(b, a%b));
}

struct wheel
{
    int x,y;
    int r;
    int w1,w2;
    int clws;
};

pair<int,int> inter(wheel a1, wheel a2, int &clw, int n1, int n2)
{
    pair<int,int> w;
    int rr=(a1.r+a2.r);
    int dx=a2.x - a1.x;
    int dy=a2.y-a1.y;
    if(dx*dx+dy*dy>rr*rr)
    {
        //cout << "RRR" << endl;
        w.first=-1;
        return w;
    }
    w.first = a1.w1*a1.r;
    w.second = a1.w2*a2.r;
    int g = gcd(w.first,w.second);
        //cout << n1 << " " << n2 << " " << a1.w1 << " " << a1.w2 << " " << clw << " " << g << endl;
    w.first/=g;
    w.second/=g;
    clw = (1+clw)%2;
    //cout << w.first << " " << w.second << " " << clw << endl;
    return w;
}

struct anss
{
    int x;
    int y;
    int z;
};


main()
{
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int T;
    cin >> T;
    while(T--)
    {
        vector<wheel> wheels;
        int n;
        cin >> n;
        wheel temp;
        cin >> temp.x >> temp.y >> temp.r;
        temp.w1=1,temp.w2=1;
        temp.clws=1;
        wheels.push_back(temp);
        anss t;
        t.x = -1;
        t.y = -1;
        t.z = -1;
        vector<anss> ans(n,t);
        for(int i=1; i<n; i++)
        {
            cin >> temp.x >> temp.y >> temp.r;
            wheels.push_back(temp);
        }
        deque<int> deq;
        deq.push_back(0);
        ans[0].x = 1;
        ans[0].y = 1;
        ans[0].z = 1;
        vector<int> used(n,0);
        while(!deq.empty())
        {
            int num = deq.front();
            deq.pop_front();
            used[num] = 1;
            temp = wheels[num];
            for(int i=0; i<n; i++)
                if(!used[i])
                {
                    int clw = temp.clws;
                    pair<int,int> w = inter( temp,wheels[i],clw, num, i);
                    if(w.first == -1)
                        continue;
                    ans[i].x=w.first;
                    ans[i].y=w.second;
                    ans[i].z = clw;
                    wheels[i].w1=w.first;
                    wheels[i].w2=w.second;
                    wheels[i].clws = clw;
                    deq.push_back(i);
                }

        }
        for(int i=0; i<n; i++)
        {
            if(ans[i].x == -1)
                cout << "not moving\n";
            else{
                    if(ans[i].y!=1)
                cout << ans[i].x << "/" << ans[i].y << " ";
            else
                cout << ans[i].x << " ";
            if(ans[i].z == 1)
                cout << "clockwise\n";
            else
                cout << "counterclockwise\n";
        }
        }



    }
    return 0;
}
