#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5, sigma = 26, logn = 20;

#define link sakldkaslkdsa
#define int long long

int len[maxn], link[maxn][logn], to[maxn][sigma];
int minr[maxn], ans[maxn];
char s[maxn];
int sz, n, last;

void init(int k)
{
    for(int i = 0; i <= k; i++)
    {
        len[i] = minr[i] = ans[i] = 0;
        memset(to[i], 0, sizeof(to[i]));
        memset(link[i], 0, sizeof(link[i]));
    }
    sz = 1;
    last = n = 0;
    s[n++] = sigma;
}

int get_link(int v)
{
    while(v && s[n - len[v] - 2] != s[n - 1]) v = link[v][0];
    return v;
}

void add_letter(char c)
{
    s[n++] = c;
    last = get_link(last);
    if(s[n - len[last] - 2] != s[n - 1]) return;
    if(!to[last][c])
    {
        len[sz] = len[last] + 2;
        link[sz][0] = to[get_link(link[last][0])][c];
        for(int i = 1; i < logn; i++)
            link[sz][i] = link[link[sz][i - 1]][i - 1];

        minr[sz] = minr[last] + 1;
        int cur_lvl = logn - 1;
        int cur = sz;
        while(cur_lvl >= 0)
        {
            if(2 * len[link[cur][cur_lvl]] > len[sz]) cur = link[cur][cur_lvl];
            cur_lvl--;
        }
        assert(len[cur] > len[sz] / 2);
        cur = link[cur][0];
        minr[sz] = min(minr[sz], len[sz] / 2 - len[cur] + ans[cur]);
        ans[sz] = min(ans[last] + 2, minr[sz] + 1);
        ans[sz] = min(ans[sz], len[sz] - len[link[sz][0]] + ans[link[sz][0]]);
        to[last][c] = sz++;
    }
    last = to[last][c];
}


main()
{
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int T;
    cin >> T;
    while(T--)
    {
        string S;
        cin >> S;
        int m = S.size();
        init(m + 42);
        int DP[m + 1];
        memset(DP, 0, sizeof(DP));
        for(int i = 1; i <= m; i++)
        {
            add_letter(S[i - 1] - 'A');
            DP[i] = DP[i - 1] + 1;
            DP[i] = min(DP[i], i - len[last] + ans[last]);
        }
        cout << DP[m] << "\n";
    }
    return 0;
}
