#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

struct Input {
	int n;
	
	bool read () {
		return scanf("%d", &n) == 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int x, k;
	
	void write () {
		if (x < 0) {
			puts("IMPOSSIBLE");
		}
		else {
			printf("%d =", n);
			forn (i, k) {
				if (i != 0) {
					printf(" +");
				}
				printf(" %d", x + i);
			}
			printf("\n");
		}
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	void check (int e, int w) {
		if (e < 2) {
			return;
		}
		
		int y = w - e + 1;
		if (y & 1) {
			return;
		}
		y >>= 1;
		if (y <= 0) {
			return;
		}
		if (x < 0 || e < k) {
			x = y;
			k = e;
		}
	}
	 
	void solve () {
		x = -1;
		for (int i = 1; i * i <= 2 * n; ++i) {
			
			if ((2 * n) % i == 0) {
				int y = (2 * n) / i;
				check(i, y);
				check(y, i);
			}
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("c.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
