#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 1010;

struct Input {
	int n;
	int x[N], y[N], r[N];
		
	bool read () {
		if (scanf ("%d", &n) != 1)
			return 0;
		forn(i, n) {
			scanf ("%d %d %d", &x[i], &y[i], &r[i]);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

int gcd (int a, int b) {
	if (a == 0 || b == 0)
		return a + b;
	return gcd(b, a % b);
}

struct Data: Input {
	int col[N];
	bool use[N];
	pair<int, int> ans[N];
	
	void write () {
		forn(i, n) {
			if (!use[i]) {
				puts("not moving");
			} else {
				int g = gcd(ans[i].fs, ans[i].sc);
				ans[i].fs /= g;
				ans[i].sc /= g;
				if (ans[i].sc == 1) {
					printf ("%d ", ans[i].fs);
				} else {
					printf ("%d/%d ", ans[i].fs, ans[i].sc);
				}
				if (col[i] == 0) {
					puts("clockwise");
				} else puts("counterclockwise");
			}
		}
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	
	void dfs (int v, int cnt) {
		use[v] = 1;
		col[v] = cnt;
		ans[v] = mp(r[0], r[v]);
		forn(i, n) {
			if (use[i]) {
				continue;
			}
			if (sqr(x[v] - x[i]) + sqr(y[v] - y[i]) <= sqr(r[v]) + sqr(r[i]) + 2 * r[v] * r[i]) {
				dfs(i, 1 - cnt);
			}
		}
	}
	
	void solve () {
		memset(col, 0, sizeof(col));
		memset(use, 0, sizeof(use));
		dfs(0, 0);
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
