#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

struct Input {
	int n;
	
	bool read () {
		return scanf ("%d", &n) == 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

const int N = 300;
bool is[N];

const int posx[10] = {3, 0, 0, 0, 1, 1, 1, 2, 2, 2};
const int posy[10] = {1, 0, 1, 2, 0, 1, 2, 0, 1, 2};

void precalc() {
	memset(is, 0, sizeof(is));
	
	for (int i = 1; i < 3; ++i) {
		forn(j, 10) {
			forn(k, 10) {
				if (posx[i] <= posx[j] && posx[j] <= posx[k] && posy[i] <= posy[j] && posy[j] <= posy[k]) {
					is[i * 100 + 10 * j + k] = 1;
				}			
			}
		}
	}
	for (int i = 0; i < 1; ++i) {
		forn(j, 10) {
			if (j == 0)
				continue;
			forn(k, 10) {
				if (posx[j] <= posx[k] && posy[j] <= posy[k]) {
					is[10 * j + k] = 1;
				}			
			}
		}
	}
	forn(i, 10) {
		is[i] = 1;
	}
}

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;	
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	void solve () {
		ans = 0;
		forn(i, N) {
			if (!is[i])
				continue;
			if (abs(i - n) < abs(ans - n)) {
				ans = i;
			}
	 	}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	precalc();
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
