#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int INF = (int) 1e9;
const int numpad[4][3] = {{1, 2, 3}, {4, 5, 6}, {7, 8, 9}, {-1, 0, -1}};
bool good[10000];
int best[201], t, k;

void go(int x, int y, int num, int len) {
	if (numpad[x][y] == -1) return;
	num = num * 10 + numpad[x][y];
	good[num] = true;
	if (len == 0) return;
	for (int dx = 0; x + dx < 4; ++dx)
		for (int dy = 0; y + dy < 3; ++dy)
			go(x + dx, y + dy, num, len - 1);
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	for (int i = 0; i < 4; ++i)
		for (int j = 0; j < 3; ++j)
			go(i, j, 0, 3);
	scanf("%d", &t);
	for (int x = 0; x < 201; ++x) {
		best[x] = INF;
		for (int y = 0; y < 10000; ++y)
			if (good[y] && (abs(y - x) < abs(best[x] - x))) best[x] = y;
	}
	for (int i = 0; i < t; ++i) {
		scanf("%d", &k);
		printf("%d\n", best[k]);
	}
	return 0;
}