#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int maxn = 200000; 

int v[maxn], c[maxn], p[maxn]; 
int d[maxn][15]; 
int n, k; 

int used[maxn]; 
int ITER = 1; 

const int inf = 1000000000; 

bool cmp(int a, int b) {
	return v[a] < v[b] ; 
}

void input() {
	scanf("%d%d", &n, &k); 
	for (int i = 0; i < n; i++) {
		scanf("%d %d", &v[i], &c[i]); 
		p[i] = i; 
	}
}

bool check(int x) {
	ITER++; 
	for (int i = 0; i < k + 1; i++) {
		int memind = -1; 
		for (int j = 0; j < n; j++) {
			if (used[j] == ITER) continue;
			if (v[j] - c[j] < x) continue; 
			if (memind == -1) memind = j; 
			if (v[j] < v[memind] || (v[j] == v[memind] && c[j] < c[memind])) memind = j; 
		}
		if (memind == -1) return false;
		x += c[memind]; 
		used[memind] = ITER; 
	}
	return true; 
}

int solution() {
	//if (v[0] == 81) {
	//	check(-37); 
	//}
	//int l = -inf, r = inf; 

	//while (r - l > 1) {
	//	int m = (r + l) / 2; 
	//	if (check(m)) l = m; else r = m;
	//}
	//
	//return l; 

	sort(p, p + n, cmp);


	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= k; j++) {
			d[i][j] = -inf;
		}
	}
	
	/*for (int i = 0; i <= k; i++) {
		d[n][i] = 0; 
	}*/

	for (int i = n - 1; i >= 0; i--) {
		d[i][0] = max(v[p[i]] - c[p[i]], d[i + 1][0]); 
		//cout << d[i][0] << " "; 
		for (int j = 1; j <= k; j++) {
			d[i][j] = d[i + 1][j]; 
			if (j == 0) continue; 
			int val = min(v[p[i]] - c[p[i]], d[i + 1][j - 1] - c[p[i]]); 
			if (val > d[i][j]) d[i][j] = val; 
			//cout << d[i][j] << " "; 
		}
		//cout << endl; 
	}

	printf("%d\n", max(0, d[0][k])); 
	return d[0][k]; 
}

void input2() {
	n = 15; 
	k = 4; 

	for (int i = 0; i < n; i++) {
		v[i] = rand() % 100; 
		c[i] = rand() % 100; 
		p[i] = i; 
	}	
}

bool used2[maxn]; 

int stupid(int i = 0) {
	int ans = -inf; 
	if (i == k) {
		for (int j = 0; j < n; j++) {
			if (!used2[j]) ans = max(ans, v[j] - c[j]); 
		}
		return ans; 
	}
	for (int j = 0; j < n; j++) {
		if (used2[j]) continue;
		used2[j] = 1; 
		ans = max(ans, min(v[j] - c[j], stupid(i + 1) - c[j]));
		used2[j] = 0; 
	}
	return ans; 
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	
	int t;  
	scanf("%d", &t); 

	for (int i = 0; i < t; i++) {
		//input2(); 
		input(); 
		solution();
		/*if (solution() != stupid()) {
			cout << "WA\n";
			cout << n << " " << k << "\n"; 
			for (int i = 0; i < n; i++) {
				cout << v[i] << " " << c[i] << "\n"; 
			}
			cout << "\n\n" << solution() << " " << stupid() << "\n\n"; 
		}*/
	}

	return 0;
}