#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 50000;

bool isprime(int x)
{
	if (x <= 1)
		return false;
	for (int i = 2; i * i <= x; i++)
		if (x % i == 0)
			return false;
	return true;
}

int pt = 0;
int P[N];

vector<pair<int, int> > D;
	
int best = inf, besta = -1, bestb = -1;
	
int n;
	
void add(int x)
{
	int y = n / x;
	if ((x + y + 1) % 2 != 0)
		return;
	int b = (x + y - 1) / 2;
	int a = (x - y + 1) / 2;
	if (1 <= a && a <= b && b <= n && b != a)
	{
		if (best > b - a + 1)
			best = b - a + 1, besta = a, bestb = b;
	}
}

void go(int i, int c = 1)
{
	if (i == D.size())
		add(c);
	else
	{
		for (int j = 0; j <= D[i].second; j++)
		{
			go(i + 1, c);
			if (j != D[i].second)
				c *= D[i].first;
		}
	}
}

void solve()
{
	scanf("%d", &n);
	D.clear();
	best = inf, besta = -1, bestb = -1;
	n *= 2;
	int _n = n;
	for (int i = 0; i < pt && P[i] * P[i] <= n; i++)
	{
		if (n % P[i] == 0)
		{
			int c = 0;
			while (n % P[i] == 0)
				n /= P[i], c++;
			D.push_back(make_pair(P[i], c));
		}
	}
	if (n != 1)
		D.push_back(make_pair(n, 1));
	n = _n;
	
	go(0);
	
	if (besta == -1)
		puts("IMPOSSIBLE");
	else
	{
		printf("%d = ", n / 2);
		for (int i = besta; i <= bestb; i++)
		{
			printf("%d", i);
			if (i != bestb)
				printf(" + ");
		}
		puts("");
	}
}

int main() {
#ifdef LOCAL42
#define TASK "C"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif

	for (int i = 0; i < N; i++)
		if (isprime(i))
			P[pt++] = i;

	int T;
	scanf("%d", &T);
	for (int i = 0; i < T; i++)
	{
		solve();
	}
	return 0;
}
