#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int dx[] = {1, 0, 1, 2, 0, 1, 2, 0, 1, 2};
int dy[] = {3, 0, 0, 0, 1, 1, 1, 2, 2, 2};

bool good(int n) {
  char str[6];
  sprintf(str, "%d", n);
  int x = 0, y = 0;
  for (int i = 0; str[i]; i++) {
    int d = (str[i] - '0');
    if (dx[d] < x || dy[d] < y) {
      return false;
    }
    x = dx[d];
    y = dy[d];
  }
  return true;
}

void test() {
  int n;
  scanf("%d", &n);
  int diff = 0;
  while (true) {
    if (n >= diff && good(n - diff)) {
      printf("%d\n", n - diff);
      return;
    }
    if (good(n + diff)) {
      printf("%d\n", n + diff);
      return;
    }
    diff++;
  }
}

int main() {
  int t;
  scanf("%d", &t);
  FOR(i, 0, t) test();
  return 0;
}
