#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

int cool[201];
int near[201];

int gr[10][10];

bool check(int n)
{
	int a[3];
	int i = 0;
	while (n > 0)
	{
		a[i++] = n % 10;
		n /= 10;
	}
	--i;
	while (i > 0)
	{
		if (gr[a[i]][a[i - 1]] == 0)
		{
			return false;
		}
		--i;
	}
	return true;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

	ZERO(cool);
	ZERO(gr);

	gr[0][0] = 1;
	for (int i = 1; i < 10; ++i)
	{
		for (int j = 1; j < 10; ++j)
		{
			gr[i][j] = (i-1) % 3 <= (j-1) % 3 && (i-1) / 3 <= (j-1) / 3;
		}

		gr[i][0] = (i-1) % 3 <= 1;
	}

	cool[0] = 1;
	for (int i = 1; i <= 200; ++i)
	{
		cool[i] = check(i);
	}

	for (int i = 1; i <= 200; ++i)
	{
		if (cool[i])
		{
			near[i] = i;
		}
		else
		{
			int l = i-1;
			int r = i+1;
			
			while (true)
			{
				if (l > 0)
				{
					if (cool[l])
					{
						near[i] = l;
						break;
					}
					--l;
				}
				if (r <= 200)
				{
					if (cool[r])
					{
						near[i] = r;
						break;
					}
					++r;
				}
			}
		}
	}

	int tests;
	cin >> tests;

	for (int tc = 0; tc < tests; ++tc)
	{
		int k;
		cin >> k;

		cout << near[k] << endl;

	}


    return 0;
}