#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 7;

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	while (t--) {		
		int n;
		scanf("%d", &n);
		ll w = 0, b = 0;

		vector <pair <ll, char> > input (n);
		for (int i = 0; i < n; i++) {
			ll cnt;
			char c;
			scanf("%lld %c\n", &cnt, &c);
			input[i] = mp(cnt, c);
			if (c == 'W')
				w += cnt;
			else
				b += cnt;
		}
		pair <ll, ll> rall = mp (w, b);
		if ((w == 0) || (b == 0)) {
			printf("%lld\n", w + b);
			continue;
		}
		w = b = 0;
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			pair <ll, char> cur = input[i];
			if (cur.Y == 'W') {
				 if ((rall.Y*w < rall.X*b) && (rall.X*b <= (w + cur.X)*rall.Y)) {
					 if ((rall.X*b) % rall.Y == 0) {
						 ans++;
						 w = w + cur.X - rall.X*b/rall.Y;
						 assert(w >= 0);
						 b = 0;
					 }
					 else
						w += cur.X;
				 }
				 else
					w += cur.X;
			}
			else {
				if ((rall.X*b < rall.Y*w) && (rall.Y*w <= (b + cur.X)*rall.X)) {
					if ((rall.Y*w) % rall.X == 0) {
						ans++;
						b = b + cur.X - rall.Y*w/rall.X;
						assert(b >= 0);
						w = 0;
					}
					else
						b += cur.X;
				}
				else
					b += cur.X;
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}