#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000007;
#define mp make_pair

long long gcd(long long a, long long b){
	if(a==0 && b==0)return 1;
	if(!b)return a;
	return gcd(b,a%b);
}


int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	long long t;
	cin >> t;
	vector<pair<long long,char> >d;
	for(int T = 0; T<t; T++) {
		long long ans = 0;
		int n;
		scanf("%d",&n);
		d.clear();
		d.resize(n);
		long long ws = 0;
		long long bs = 0;
		for(int i = 0; i<n; i++) {
			scanf("%lld %c",&d[i].first,&d[i].second);
			if (d[i].second == 'W') {
				ws+=d[i].first;
			}else{
				bs+=d[i].first;
			}
		}
		if(ws == 0) {
			printf("%lld\n",bs);
			continue;
		}
		if(bs == 0) {
			printf("%lld\n",ws);
			continue;
		}
		long long g = gcd(ws,bs);
		long long B1,W1;
		B1 = bs/g;
		W1 = ws/g;
		long long sumw = 0;
		long long sumb = 0;
		if (d[0].second == 'W') {
			sumw+=d[0].first;
		}else{
			sumb+=d[0].first;
		}
		for(int i = 1; i<n; i++) {
			if (d[i].second == 'B') {
				if (sumw*B1%W1 ==0 && sumw*B1/W1-sumb > 0) {
					int needb = sumw*B1/W1-sumb;
					if(d[i].first >=needb) {
						ans++;
					}
				}
				sumb+=d[i].first;
			}else{
				if (sumb*W1%B1 ==0 && sumb*W1/B1-sumw > 0) {
					int needw = sumb*W1/B1-sumw;
					if(d[i].first >=needw) {
						ans++;
					}
				}
				sumw+=d[i].first;
			}
		}
		printf("%lld\n",ans);
	}


	return 0;
}