
#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

string a, b, c;
int mem[1000100][2][2];

int mod = 1000000009;

char mn(char c, char x) {
    if (c == 0) return 0;
    if (c != '?') return c;
    return 'a';
    //return max('a', x);
}

char mx(char c) {
    if (c == 0) return 0;
    if (c != '?') return c;
    return 'z';
}

int cnt(int at, bool p1, bool p2) {
    if (at >= size(a) && at >= size(b) && at >= size(c))
        return !p1 && !p2 ? 1 : 0;

    if (mem[at][p1][p2] != -1)
        return mem[at][p1][p2];

    //printf("%d %d %d\n", at, p1 ? 1 : 0, p2 ? 1 : 0);

    char ac1 = at < size(a) ? a[at] : 0;
    char ac2 = at < size(b) ? b[at] : 0;
    char ac3 = at < size(c) ? c[at] : 0;

    int res = 0;

    for (int x = mn(ac2, 0); x <= mx(ac2); x++) {

        for (int wp1 = 0; wp1 <= p1; wp1++) {
            for (int wp2 = 0; wp2 <= p2; wp2++) {

                int amn = ac1 != '?' ? ac1 : 'a';
                int amx = ac1 != '?' ? ac1 : (p1 ? x : 'z');
                //int amx = ac1 != '?' ? ac1 : 'z';
                int cmn = ac3 != '?' ? ac3 : (p2 ? x : 'a');
                //int cmn = ac3 != '?' ? ac3 : 'a';
                int cmx = ac3 != '?' ? ac3 : 'z';

                if (!wp1 && p1) amx = min(amx, x-1);
                if (!wp2 && p2) cmn = max(cmn, x+1);

                //printf("[%d,%d] %d [%d,%d] (%d,%d)\n", amn, amx, x, cmn, cmx, wp1, wp2);

                if (amn > amx || cmn > cmx)
                    continue;

                /*
                amx = min(amx, x);
                cmn = max(cmn, x);
                */

                //printf("%d %d %d\n", amn, x, amx);
                if (wp1 && !( amn <= x && x <= amx )) {
                    //printf("A\n");
                    continue;
                }
                if (wp2 && !( cmn <= x && x <= cmx )) {
                    //printf("B\n");
                    continue;
                }

                if (wp1) amn = amx = x;
                //else amx = min(amx, x - 1);
                if (wp2) cmn = cmx = x;
                //else cmn = max(cmn, x + 1);

                if (amn > amx || cmn > cmx)
                    continue;

                /*
                int sub1 = !wp1 && amn <= x && x <= amx;
                int sub2 = !wp2 && cmn <= x && x <= cmx;
                */

                //printf(" - [%d,%d] %d [%d,%d] (%d,%d)\n", amn, amx, x, cmn, cmx, wp1, wp2);

                ll cur = (ll)(amx - amn + 1) * (cmx - cmn + 1) * cnt(at + 1, wp1, wp2);
                cur %= mod;
                res += cur;
                if (res >= mod) {
                    res -= mod;
                }
            }
        }

    }

    /*
    if (ac1 != '?' && ac2 != '?' && ac1 > ac2) {
        res = 0;
    } else if (ac1 != '?' && ac3 != '?' && ac1 > ac3) {
        res = 0;
    } else if (ac2 != '?' && ac3 != '?' && ac2 > ac3) {
        res = 0;
    } else if (ac1 == '?' && ac2 == '?' && ac3 == '?') {



    } else if (ac1 == '?' && ac2 == '?') {
    } else if (ac1 == '?' && ac3 == '?') {
    } else if (ac2 == '?' && ac3 == '?') {
    } else if (ac1 == '?') {
        char mn = 'a',
             mx = ac2;
        if (mn < mx) {
            //res = cnt(at + 1, );
        }
        assert(mn <= mx);
        //res += cnt(at + 1, );
    } else if (ac2 == '?') {
    } else if (ac3 == '?') {
    } else {
        res = cnt(at + 1, p1 && ac1 == ac2, p2 && ac2 == ac3);
    }

    //int res = 0;
    for (char c1 = mn(ac1, 0); c1 <= mx(ac1); c1++) {
        //printf("a = %c\n", c1);
        for (char c2 = mn(ac2, c1); c2 <= mx(ac2); c2++) {
            if (c2 < c1 && p1) continue;
            //printf("b = %c\n", c2);
            for (char c3 = mn(ac3, c2); c3 <= mx(ac3); c3++) {
                if (c3 < c2 && p2) continue;
                //printf("c = %c\n", c3);
                //printf("%d %c %c %c\n", at, c1, c2, c3);
                res += cnt(at + 1, p1 && c1 == c2, p2 && c2 == c3);
                if (res >= mod) {
                    res -= mod;
                }
            }
        }
    }
    */

    return mem[at][p1][p2] = res;
}

int cntz[28][28][28][2][2][2][2];
int idx[300];

int main() {

    memset(cntz, 0, sizeof(cntz));

    vector<char> poss;
    for (char x = 'a'; x <= 'z'; x++) {
        poss.push_back(x);
    }
    poss.push_back('?');
    poss.push_back(0);

    for (int i = 0; i < size(poss); i++) {
        idx[poss[i]] = i;
    }

    for (int i = 0; i < size(poss); i++) {
        for (int j = 0; j < size(poss); j++) {
            for (int k = 0; k < size(poss); k++) {

                char ac1 = poss[i];
                char ac2 = poss[j];
                char ac3 = poss[k];

                for (int p1 = 0; p1 < 2; p1++) {
                    for (int p2 = 0; p2 < 2; p2++) {

                        for (int x = mn(ac2, 0); x <= mx(ac2); x++) {

                            for (int wp1 = 0; wp1 <= p1; wp1++) {
                                for (int wp2 = 0; wp2 <= p2; wp2++) {

                                    int amn = ac1 != '?' ? ac1 : 'a';
                                    int amx = ac1 != '?' ? ac1 : (p1 ? x : 'z');
                                    int cmn = ac3 != '?' ? ac3 : (p2 ? x : 'a');
                                    int cmx = ac3 != '?' ? ac3 : 'z';

                                    if (!wp1 && p1) amx = min(amx, x-1);
                                    if (!wp2 && p2) cmn = max(cmn, x+1);


                                    if (amn > amx || cmn > cmx)
                                        continue;

                                    if (wp1 && !( amn <= x && x <= amx )) {
                                        continue;
                                    }
                                    if (wp2 && !( cmn <= x && x <= cmx )) {
                                        continue;
                                    }

                                    if (wp1) amn = amx = x;
                                    if (wp2) cmn = cmx = x;

                                    if (amn > amx || cmn > cmx)
                                        continue;

                                    cntz[i][j][k][p1][p2][wp1][wp2] += ((ll)(amx - amn + 1) * (cmx - cmn + 1)) % mod;
                                    cntz[i][j][k][p1][p2][wp1][wp2] %= mod;

                                }
                            }
                        }


                    }
                }

            }
        }
    }

    //return 0;

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        getline(cin, a);
        getline(cin, b);
        getline(cin, c);
        //memset(mem, -1, sizeof(mem));

        int dp[2][2][2];
        for (int at = max(size(a), max(size(b), size(c))); at >= 0; at--) {
            for (int p1 = 0; p1 < 2; p1++) {
                for (int p2 = 0; p2 < 2; p2++) {

                    if (at >= size(a) && at >= size(b) && at >= size(c)) {
                        dp[at&1][p1][p2] = !p1 && !p2 ? 1 : 0;
                        continue;
                    }

                    char ac1 = at < size(a) ? a[at] : 0;
                    char ac2 = at < size(b) ? b[at] : 0;
                    char ac3 = at < size(c) ? c[at] : 0;

                    int i = idx[ac1];
                    int j = idx[ac2];
                    int k = idx[ac3];

                    int res = 0;

                    for (int wp1 = 0; wp1 <= p1; wp1++) {
                        for (int wp2 = 0; wp2 <= p2; wp2++) {

                            ll cur = (ll)cntz[i][j][k][p1][p2][wp1][wp2] * dp[~at&1][wp1][wp2];
                            cur %= mod;
                            res += cur;
                            if (res >= mod) {
                                res -= mod;
                            }
                        }
                    }

                    dp[at&1][p1][p2] = res;
                }
            }
        }


        //printf("%d\n", cnt(0, true, true));
        printf("%d\n", dp[0][1][1]);
    }

    return 0;
}
